searchData={"items":[{"type":"module","title":"Xbase","doc":"Documentation for `Xbase`.","ref":"Xbase.html"},{"type":"function","title":"Xbase.hello/0","doc":"Hello world.","ref":"Xbase.html#hello/0"},{"type":"function","title":"Examples - Xbase.hello/0","doc":"iex> Xbase.hello()\n    :world","ref":"Xbase.html#hello/0-examples"},{"type":"module","title":"Xbase.Types.CdxFile","doc":"CDX file structure containing header information and file handle.\n\nRepresents an opened CDX index file with parsed header and file descriptor\nfor reading B-tree nodes and performing index operations.","ref":"Xbase.Types.CdxFile.html"},{"type":"type","title":"Xbase.Types.CdxFile.t/0","doc":"","ref":"Xbase.Types.CdxFile.html#t:t/0"},{"type":"module","title":"Xbase.Types.CdxHeader","doc":"CDX index file header structure containing metadata about the index file.\n\nThe header is a 512-byte structure at the beginning of every CDX file,\ncontaining information about the B-tree root and index configuration.","ref":"Xbase.Types.CdxHeader.html"},{"type":"type","title":"Xbase.Types.CdxHeader.t/0","doc":"","ref":"Xbase.Types.CdxHeader.html#t:t/0"},{"type":"module","title":"Xbase.Types.CdxNode","doc":"CDX B-tree node structure representing a page in the index tree.\n\nEach node is 512 bytes and can be a root, branch, or leaf node\ncontaining keys and pointers for B-tree navigation.","ref":"Xbase.Types.CdxNode.html"},{"type":"type","title":"Xbase.Types.CdxNode.t/0","doc":"","ref":"Xbase.Types.CdxNode.html#t:t/0"},{"type":"module","title":"Xbase.Types.DbtFile","doc":"DBT file structure containing header information and file handle.\n\nRepresents an opened DBT memo file with parsed header and file descriptor\nfor reading memo content blocks.","ref":"Xbase.Types.DbtFile.html"},{"type":"type","title":"Xbase.Types.DbtFile.t/0","doc":"","ref":"Xbase.Types.DbtFile.html#t:t/0"},{"type":"module","title":"Xbase.Types.DbtHeader","doc":"DBT (memo) file header structure containing metadata about memo storage.\n\nThe header is a 512-byte structure at the beginning of every DBT file,\ncontaining information about block allocation and format version.","ref":"Xbase.Types.DbtHeader.html"},{"type":"type","title":"Xbase.Types.DbtHeader.t/0","doc":"","ref":"Xbase.Types.DbtHeader.html#t:t/0"},{"type":"module","title":"Xbase.Types.FieldDescriptor","doc":"DBF field descriptor structure defining individual field properties.\n\nEach field descriptor is a 32-byte structure describing one field in the database.","ref":"Xbase.Types.FieldDescriptor.html"},{"type":"type","title":"Xbase.Types.FieldDescriptor.t/0","doc":"","ref":"Xbase.Types.FieldDescriptor.html#t:t/0"},{"type":"module","title":"Xbase.Types.Header","doc":"DBF file header structure containing metadata about the database file.\n\nThe header is a 32-byte structure at the beginning of every DBF file.","ref":"Xbase.Types.Header.html"},{"type":"type","title":"Xbase.Types.Header.t/0","doc":"","ref":"Xbase.Types.Header.html#t:t/0"},{"type":"module","title":"Xbase.Types.IndexKey","doc":"Index key structure representing a key-value pair in a CDX index.\n\nContains the index key data and associated record pointer for\nB-tree operations and record lookups.","ref":"Xbase.Types.IndexKey.html"},{"type":"type","title":"Xbase.Types.IndexKey.t/0","doc":"","ref":"Xbase.Types.IndexKey.html#t:t/0"},{"type":"module","title":"Xbase.Types.Record","doc":"DBF record structure containing parsed field data and metadata.\n\nRepresents a single record from a DBF file with parsed field values,\ndeletion status, and raw binary data for debugging purposes.","ref":"Xbase.Types.Record.html"},{"type":"type","title":"Xbase.Types.Record.t/0","doc":"","ref":"Xbase.Types.Record.html#t:t/0"},{"type":"module","title":"Xbase.Parser","doc":"Binary parser for DBF file format components.\n\nThis module provides functions to parse DBF file headers and field descriptors\nfrom binary data using Elixir's efficient binary pattern matching.","ref":"Xbase.Parser.html"},{"type":"function","title":"Xbase.Parser.append_record/2","doc":"Appends a new record to the DBF file.","ref":"Xbase.Parser.html#append_record/2"},{"type":"function","title":"Parameters - Xbase.Parser.append_record/2","doc":"- `dbf` - DBF file structure from open_dbf/1 or create_dbf/2\n- `record_data` - Map of field name => value","ref":"Xbase.Parser.html#append_record/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.append_record/2","doc":"- `{:ok, updated_dbf}` - Successfully appended with updated DBF structure\n- `{:error, reason}` - Error appending record","ref":"Xbase.Parser.html#append_record/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.append_record/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> {:ok, updated_dbf} = Xbase.Parser.append_record(dbf, %{\"NAME\" => \"John\", \"AGE\" => 30})","ref":"Xbase.Parser.html#append_record/2-examples"},{"type":"function","title":"Xbase.Parser.batch_append_records/2","doc":"Appends multiple records to the DBF file in a single batch operation.","ref":"Xbase.Parser.html#batch_append_records/2"},{"type":"function","title":"Parameters - Xbase.Parser.batch_append_records/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `records` - List of record data maps to append","ref":"Xbase.Parser.html#batch_append_records/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.batch_append_records/2","doc":"- `{:ok, updated_dbf}` - Successfully appended all records\n- `{:error, reason}` - Error during batch append","ref":"Xbase.Parser.html#batch_append_records/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.batch_append_records/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n    iex> records = [%{\"NAME\" => \"John\"}, %{\"NAME\" => \"Jane\"}]\n    iex> Xbase.Parser.batch_append_records(dbf, records)\n    {:ok, updated_dbf}","ref":"Xbase.Parser.html#batch_append_records/2-examples"},{"type":"function","title":"Xbase.Parser.batch_delete/2","doc":"Deletes multiple records by their indices in a single operation.","ref":"Xbase.Parser.html#batch_delete/2"},{"type":"function","title":"Parameters - Xbase.Parser.batch_delete/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `indices` - List of record indices to delete","ref":"Xbase.Parser.html#batch_delete/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.batch_delete/2","doc":"- `{:ok, updated_dbf}` - Successfully deleted records\n- `{:error, reason}` - Error during deletion","ref":"Xbase.Parser.html#batch_delete/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.batch_delete/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n    iex> Xbase.Parser.batch_delete(dbf, [1, 5, 10])\n    {:ok, updated_dbf}","ref":"Xbase.Parser.html#batch_delete/2-examples"},{"type":"function","title":"Xbase.Parser.batch_delete_range/3","doc":"Deletes records in a specified index range (inclusive).","ref":"Xbase.Parser.html#batch_delete_range/3"},{"type":"function","title":"Parameters - Xbase.Parser.batch_delete_range/3","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `start_index` - Starting index (inclusive)\n- `end_index` - Ending index (inclusive)","ref":"Xbase.Parser.html#batch_delete_range/3-parameters"},{"type":"function","title":"Returns - Xbase.Parser.batch_delete_range/3","doc":"- `{:ok, updated_dbf}` - Successfully deleted records in range\n- `{:error, reason}` - Error during deletion","ref":"Xbase.Parser.html#batch_delete_range/3-returns"},{"type":"function","title":"Examples - Xbase.Parser.batch_delete_range/3","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n    iex> Xbase.Parser.batch_delete_range(dbf, 10, 20)\n    {:ok, updated_dbf}","ref":"Xbase.Parser.html#batch_delete_range/3-examples"},{"type":"function","title":"Xbase.Parser.batch_delete_where/2","doc":"Deletes records that match a given condition function.","ref":"Xbase.Parser.html#batch_delete_where/2"},{"type":"function","title":"Parameters - Xbase.Parser.batch_delete_where/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `condition_fn` - Function that takes record data and returns true to delete","ref":"Xbase.Parser.html#batch_delete_where/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.batch_delete_where/2","doc":"- `{:ok, updated_dbf}` - Successfully deleted matching records\n- `{:error, reason}` - Error during deletion","ref":"Xbase.Parser.html#batch_delete_where/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.batch_delete_where/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n    iex> condition = fn record -> record[\"STATUS\"] == \"inactive\" end\n    iex> Xbase.Parser.batch_delete_where(dbf, condition)\n    {:ok, updated_dbf}","ref":"Xbase.Parser.html#batch_delete_where/2-examples"},{"type":"function","title":"Xbase.Parser.batch_update_records/2","doc":"Updates multiple records by their indices in a single batch operation.","ref":"Xbase.Parser.html#batch_update_records/2"},{"type":"function","title":"Parameters - Xbase.Parser.batch_update_records/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `updates` - List of {index, update_data} tuples","ref":"Xbase.Parser.html#batch_update_records/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.batch_update_records/2","doc":"- `{:ok, updated_dbf}` - Successfully updated all records\n- `{:error, reason}` - Error during batch update","ref":"Xbase.Parser.html#batch_update_records/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.batch_update_records/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n    iex> updates = [{0, %{\"NAME\" => \"John\"}}, {2, %{\"STATUS\" => \"active\"}}]\n    iex> Xbase.Parser.batch_update_records(dbf, updates)\n    {:ok, updated_dbf}","ref":"Xbase.Parser.html#batch_update_records/2-examples"},{"type":"function","title":"Xbase.Parser.batch_update_records_with_conflict_check/2","doc":"Updates multiple records with write conflict detection.","ref":"Xbase.Parser.html#batch_update_records_with_conflict_check/2"},{"type":"function","title":"Parameters - Xbase.Parser.batch_update_records_with_conflict_check/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `updates` - List of {index, update_data} tuples","ref":"Xbase.Parser.html#batch_update_records_with_conflict_check/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.batch_update_records_with_conflict_check/2","doc":"- `{:ok, updated_dbf}` - Successfully updated records\n- `{:error, :write_conflict}` - File was modified by another process\n- `{:error, reason}` - Other error during batch update","ref":"Xbase.Parser.html#batch_update_records_with_conflict_check/2-returns"},{"type":"function","title":"Xbase.Parser.batch_update_where/3","doc":"Updates records that match a given condition function.","ref":"Xbase.Parser.html#batch_update_where/3"},{"type":"function","title":"Parameters - Xbase.Parser.batch_update_where/3","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `condition_fn` - Function that takes record data and returns true to update\n- `update_data` - Map of field updates to apply","ref":"Xbase.Parser.html#batch_update_where/3-parameters"},{"type":"function","title":"Returns - Xbase.Parser.batch_update_where/3","doc":"- `{:ok, updated_dbf}` - Successfully updated matching records\n- `{:error, reason}` - Error during batch update","ref":"Xbase.Parser.html#batch_update_where/3-returns"},{"type":"function","title":"Examples - Xbase.Parser.batch_update_where/3","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n    iex> condition = fn record -> record[\"STATUS\"] == \"pending\" end\n    iex> Xbase.Parser.batch_update_where(dbf, condition, %{\"STATUS\" => \"active\"})\n    {:ok, updated_dbf}","ref":"Xbase.Parser.html#batch_update_where/3-examples"},{"type":"function","title":"Xbase.Parser.calculate_record_offset/2","doc":"Calculates the byte offset for a specific record in the file.","ref":"Xbase.Parser.html#calculate_record_offset/2"},{"type":"function","title":"Parameters - Xbase.Parser.calculate_record_offset/2","doc":"- `header` - The DBF header containing file structure information\n- `record_index` - Zero-based record index","ref":"Xbase.Parser.html#calculate_record_offset/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.calculate_record_offset/2","doc":"- The byte offset where the record starts","ref":"Xbase.Parser.html#calculate_record_offset/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.calculate_record_offset/2","doc":"iex> header = %Header{header_length: 97, record_length: 25}\n    iex> Xbase.Parser.calculate_record_offset(header, 0)\n    97\n    iex> Xbase.Parser.calculate_record_offset(header, 1)\n    122","ref":"Xbase.Parser.html#calculate_record_offset/2-examples"},{"type":"function","title":"Xbase.Parser.close_dbf/1","doc":"Closes a DBF file handle.","ref":"Xbase.Parser.html#close_dbf/1"},{"type":"function","title":"Parameters - Xbase.Parser.close_dbf/1","doc":"- `dbf` - DBF structure returned from open_dbf/1","ref":"Xbase.Parser.html#close_dbf/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.close_dbf/1","doc":"- `:ok` - File closed successfully","ref":"Xbase.Parser.html#close_dbf/1-returns"},{"type":"function","title":"Xbase.Parser.count_active_records/1","doc":"Counts the number of active (non-deleted) records in the DBF file.","ref":"Xbase.Parser.html#count_active_records/1"},{"type":"function","title":"Parameters - Xbase.Parser.count_active_records/1","doc":"- `dbf` - DBF file structure from open_dbf/1","ref":"Xbase.Parser.html#count_active_records/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.count_active_records/1","doc":"- `{:ok, count}` - Number of active records\n- `{:error, reason}` - Error reading records","ref":"Xbase.Parser.html#count_active_records/1-returns"},{"type":"function","title":"Examples - Xbase.Parser.count_active_records/1","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> Xbase.Parser.count_active_records(dbf)\n    {:ok, 150}","ref":"Xbase.Parser.html#count_active_records/1-examples"},{"type":"function","title":"Xbase.Parser.count_deleted_records/1","doc":"Counts the number of deleted records in the DBF file.","ref":"Xbase.Parser.html#count_deleted_records/1"},{"type":"function","title":"Parameters - Xbase.Parser.count_deleted_records/1","doc":"- `dbf` - DBF file structure from open_dbf/1","ref":"Xbase.Parser.html#count_deleted_records/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.count_deleted_records/1","doc":"- `{:ok, count}` - Number of deleted records\n- `{:error, reason}` - Error reading records","ref":"Xbase.Parser.html#count_deleted_records/1-returns"},{"type":"function","title":"Examples - Xbase.Parser.count_deleted_records/1","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> Xbase.Parser.count_deleted_records(dbf)\n    {:ok, 25}","ref":"Xbase.Parser.html#count_deleted_records/1-examples"},{"type":"function","title":"Xbase.Parser.create_dbf/3","doc":"Creates a new DBF file with the specified field structure.","ref":"Xbase.Parser.html#create_dbf/3"},{"type":"function","title":"Parameters - Xbase.Parser.create_dbf/3","doc":"- `path` - Path for the new DBF file\n- `fields` - List of field descriptors defining the schema\n- `opts` - Options (version, overwrite)","ref":"Xbase.Parser.html#create_dbf/3-parameters"},{"type":"function","title":"Returns - Xbase.Parser.create_dbf/3","doc":"- `{:ok, dbf}` - Successfully created DBF file structure\n- `{:error, reason}` - Error creating file","ref":"Xbase.Parser.html#create_dbf/3-returns"},{"type":"function","title":"Examples - Xbase.Parser.create_dbf/3","doc":"iex> fields = [%FieldDescriptor{name: \"NAME\", type: \"C\", length: 20}]\n    iex> {:ok, dbf} = Xbase.Parser.create_dbf(\"new.dbf\", fields)","ref":"Xbase.Parser.html#create_dbf/3-examples"},{"type":"function","title":"Xbase.Parser.ensure_header_consistency/1","doc":"Ensures header consistency for all write operations.\nCall this after any operation that modifies the DBF structure.","ref":"Xbase.Parser.html#ensure_header_consistency/1"},{"type":"function","title":"Parameters - Xbase.Parser.ensure_header_consistency/1","doc":"- `dbf` - DBF file structure","ref":"Xbase.Parser.html#ensure_header_consistency/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.ensure_header_consistency/1","doc":"- `{:ok, dbf}` - Header is consistent\n- `{:error, reason}` - Header inconsistency detected","ref":"Xbase.Parser.html#ensure_header_consistency/1-returns"},{"type":"function","title":"Xbase.Parser.get_deletion_flag/1","doc":"Extracts the deletion flag from record data.","ref":"Xbase.Parser.html#get_deletion_flag/1"},{"type":"function","title":"Parameters - Xbase.Parser.get_deletion_flag/1","doc":"- `record_binary` - The raw record binary data","ref":"Xbase.Parser.html#get_deletion_flag/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.get_deletion_flag/1","doc":"- `{:ok, boolean}` - true if deleted (0x2A), false if active (0x20)\n- `{:error, reason}` - Error for invalid data","ref":"Xbase.Parser.html#get_deletion_flag/1-returns"},{"type":"function","title":"Xbase.Parser.is_valid_record_index?/2","doc":"Validates if a record index is within the valid range for the file.","ref":"Xbase.Parser.html#is_valid_record_index?/2"},{"type":"function","title":"Parameters - Xbase.Parser.is_valid_record_index?/2","doc":"- `header` - The DBF header containing record count\n- `record_index` - Zero-based record index to validate","ref":"Xbase.Parser.html#is_valid_record_index?/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.is_valid_record_index?/2","doc":"- `true` if the index is valid, `false` otherwise","ref":"Xbase.Parser.html#is_valid_record_index?/2-returns"},{"type":"function","title":"Xbase.Parser.mark_deleted/2","doc":"Marks a record as deleted in the DBF file.","ref":"Xbase.Parser.html#mark_deleted/2"},{"type":"function","title":"Parameters - Xbase.Parser.mark_deleted/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `record_index` - Zero-based index of the record to mark as deleted","ref":"Xbase.Parser.html#mark_deleted/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.mark_deleted/2","doc":"- `{:ok, updated_dbf}` - Successfully marked as deleted with updated DBF structure\n- `{:error, reason}` - Error marking record as deleted","ref":"Xbase.Parser.html#mark_deleted/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.mark_deleted/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> {:ok, updated_dbf} = Xbase.Parser.mark_deleted(dbf, 2)","ref":"Xbase.Parser.html#mark_deleted/2-examples"},{"type":"function","title":"Xbase.Parser.mark_deleted_with_conflict_check/2","doc":"Marks a record as deleted with write conflict detection.","ref":"Xbase.Parser.html#mark_deleted_with_conflict_check/2"},{"type":"function","title":"Parameters - Xbase.Parser.mark_deleted_with_conflict_check/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `record_index` - Index of record to delete","ref":"Xbase.Parser.html#mark_deleted_with_conflict_check/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.mark_deleted_with_conflict_check/2","doc":"- `{:ok, updated_dbf}` - Successfully marked record as deleted\n- `{:error, :write_conflict}` - File was modified by another process\n- `{:error, reason}` - Other error during deletion","ref":"Xbase.Parser.html#mark_deleted_with_conflict_check/2-returns"},{"type":"function","title":"Xbase.Parser.memory_usage/0","doc":"Returns current memory usage statistics.","ref":"Xbase.Parser.html#memory_usage/0"},{"type":"function","title":"Returns - Xbase.Parser.memory_usage/0","doc":"- `%{total: integer, processes: integer, system: integer}` - Memory usage in bytes","ref":"Xbase.Parser.html#memory_usage/0-returns"},{"type":"function","title":"Examples - Xbase.Parser.memory_usage/0","doc":"memory = Xbase.Parser.memory_usage()\n    # => %{total: 52428800, processes: 12345, system: 9876, ...}","ref":"Xbase.Parser.html#memory_usage/0-examples"},{"type":"function","title":"Xbase.Parser.open_dbf/1","doc":"Opens a DBF file and parses its header and field descriptors.","ref":"Xbase.Parser.html#open_dbf/1"},{"type":"function","title":"Parameters - Xbase.Parser.open_dbf/1","doc":"- `path` - Path to the DBF file","ref":"Xbase.Parser.html#open_dbf/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.open_dbf/1","doc":"- `{:ok, %{header: header, fields: fields, file: file}}` - Successfully opened DBF\n- `{:error, reason}` - Error opening or parsing file","ref":"Xbase.Parser.html#open_dbf/1-returns"},{"type":"function","title":"Examples - Xbase.Parser.open_dbf/1","doc":"iex> Xbase.Parser.open_dbf(\"data.dbf\")\n    {:ok, %{header: %Header{...}, fields: [...], file: #Port<...>}}","ref":"Xbase.Parser.html#open_dbf/1-examples"},{"type":"function","title":"Xbase.Parser.open_dbf/2","doc":"Opens a DBF file and parses its header and field descriptors with specified file modes.","ref":"Xbase.Parser.html#open_dbf/2"},{"type":"function","title":"Parameters - Xbase.Parser.open_dbf/2","doc":"- `path` - Path to the DBF file\n- `modes` - List of file open modes (e.g., [:read], [:read, :write])","ref":"Xbase.Parser.html#open_dbf/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.open_dbf/2","doc":"- `{:ok, %{header: header, fields: fields, file: file}}` - Successfully opened DBF\n- `{:error, reason}` - Error opening or parsing file","ref":"Xbase.Parser.html#open_dbf/2-returns"},{"type":"function","title":"Xbase.Parser.pack/2","doc":"Packs a DBF file by removing all deleted records and creating a compacted file.","ref":"Xbase.Parser.html#pack/2"},{"type":"function","title":"Parameters - Xbase.Parser.pack/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `output_path` - Path for the packed output file","ref":"Xbase.Parser.html#pack/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.pack/2","doc":"- `{:ok, packed_dbf}` - Successfully packed DBF file structure\n- `{:error, reason}` - Error packing file","ref":"Xbase.Parser.html#pack/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.pack/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> {:ok, packed_dbf} = Xbase.Parser.pack(dbf, \"data_packed.dbf\")","ref":"Xbase.Parser.html#pack/2-examples"},{"type":"function","title":"Xbase.Parser.pack_with_conflict_check/2","doc":"Packs a DBF file with write conflict detection.","ref":"Xbase.Parser.html#pack_with_conflict_check/2"},{"type":"function","title":"Parameters - Xbase.Parser.pack_with_conflict_check/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `output_path` - Path for the packed file","ref":"Xbase.Parser.html#pack_with_conflict_check/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.pack_with_conflict_check/2","doc":"- `{:ok, packed_dbf}` - Successfully packed file\n- `{:error, :write_conflict}` - File was modified by another process\n- `{:error, reason}` - Other error during packing","ref":"Xbase.Parser.html#pack_with_conflict_check/2-returns"},{"type":"function","title":"Xbase.Parser.parse_fields/2","doc":"Parses field descriptors from binary data until field terminator (0x0D).","ref":"Xbase.Parser.html#parse_fields/2"},{"type":"function","title":"Parameters - Xbase.Parser.parse_fields/2","doc":"- `binary` - The binary data containing field descriptors\n- `offset` - Starting offset in the binary data","ref":"Xbase.Parser.html#parse_fields/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.parse_fields/2","doc":"- `{:ok, [%FieldDescriptor{}]}` - List of parsed field descriptors\n- `{:error, reason}` - Parse error with reason","ref":"Xbase.Parser.html#parse_fields/2-returns"},{"type":"function","title":"Xbase.Parser.parse_header/1","doc":"Parses a 32-byte DBF header from binary data.","ref":"Xbase.Parser.html#parse_header/1"},{"type":"function","title":"Parameters - Xbase.Parser.parse_header/1","doc":"- `binary` - The binary data containing the DBF header","ref":"Xbase.Parser.html#parse_header/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.parse_header/1","doc":"- `{:ok, %Header{}}` - Successfully parsed header\n- `{:error, reason}` - Parse error with reason","ref":"Xbase.Parser.html#parse_header/1-returns"},{"type":"function","title":"Examples - Xbase.Parser.parse_header/1","doc":"iex> header_data = <<0x03, 124, 12, 17, 100::little-32, 161::little-16, 50::little-16, 0::16, 0, 0, 0::12*8, 0, 0, 0::16>>\n    iex> Xbase.Parser.parse_header(header_data)\n    {:ok, %Xbase.Types.Header{version: 3, record_count: 100, ...}}","ref":"Xbase.Parser.html#parse_header/1-examples"},{"type":"function","title":"Xbase.Parser.parse_record_data/2","doc":"Parses record field data according to field descriptors.","ref":"Xbase.Parser.html#parse_record_data/2"},{"type":"function","title":"Parameters - Xbase.Parser.parse_record_data/2","doc":"- `record_data` - Binary data for the record fields (without deletion flag)\n- `fields` - List of field descriptors","ref":"Xbase.Parser.html#parse_record_data/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.parse_record_data/2","doc":"- `{:ok, %{field_name => parsed_value}}` - Parsed field data\n- `{:error, reason}` - Parse error","ref":"Xbase.Parser.html#parse_record_data/2-returns"},{"type":"function","title":"Xbase.Parser.read_in_chunks/2","doc":"Reads records in chunks of specified size.","ref":"Xbase.Parser.html#read_in_chunks/2"},{"type":"function","title":"Parameters - Xbase.Parser.read_in_chunks/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `chunk_size` - Number of records per chunk","ref":"Xbase.Parser.html#read_in_chunks/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.read_in_chunks/2","doc":"- `Stream.t()` - Stream of record lists (chunks)","ref":"Xbase.Parser.html#read_in_chunks/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.read_in_chunks/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> chunks = Xbase.Parser.read_in_chunks(dbf, 100)\n    iex> Enum.each(chunks, fn chunk -> process_chunk(chunk) end)\n    :ok","ref":"Xbase.Parser.html#read_in_chunks/2-examples"},{"type":"function","title":"Xbase.Parser.read_in_chunks_with_progress/3","doc":"Reads records in chunks with progress reporting.","ref":"Xbase.Parser.html#read_in_chunks_with_progress/3"},{"type":"function","title":"Parameters - Xbase.Parser.read_in_chunks_with_progress/3","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `chunk_size` - Number of records per chunk\n- `progress_fn` - Function called with progress info: `fn %{current: int, total: int, percentage: float} -> any end`","ref":"Xbase.Parser.html#read_in_chunks_with_progress/3-parameters"},{"type":"function","title":"Returns - Xbase.Parser.read_in_chunks_with_progress/3","doc":"- `Stream.t()` - Stream of record lists (chunks) with progress reporting","ref":"Xbase.Parser.html#read_in_chunks_with_progress/3-returns"},{"type":"function","title":"Examples - Xbase.Parser.read_in_chunks_with_progress/3","doc":"progress_fn = fn prog -> IO.puts(\"Progress: \" <> to_string(prog.percentage) <> \"%\") end\n    chunks = Xbase.Parser.read_in_chunks_with_progress(dbf, 100, progress_fn)\n    Enum.each(chunks, fn chunk -> process_chunk(chunk) end)","ref":"Xbase.Parser.html#read_in_chunks_with_progress/3-examples"},{"type":"function","title":"Xbase.Parser.read_record/2","doc":"Reads a complete record from the DBF file at the specified index.","ref":"Xbase.Parser.html#read_record/2"},{"type":"function","title":"Parameters - Xbase.Parser.read_record/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `record_index` - Zero-based record index","ref":"Xbase.Parser.html#read_record/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.read_record/2","doc":"- `{:ok, %Record{}}` - Successfully parsed record\n- `{:error, reason}` - Error reading or parsing record","ref":"Xbase.Parser.html#read_record/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.read_record/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> {:ok, record} = Xbase.Parser.read_record(dbf, 0)\n    iex> record.data[\"NAME\"]\n    \"John Doe\"","ref":"Xbase.Parser.html#read_record/2-examples"},{"type":"function","title":"Xbase.Parser.read_records/1","doc":"Reads all records from a DBF file.","ref":"Xbase.Parser.html#read_records/1"},{"type":"function","title":"Parameters - Xbase.Parser.read_records/1","doc":"- `dbf` - DBF file structure from open_dbf/1","ref":"Xbase.Parser.html#read_records/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.read_records/1","doc":"- `{:ok, [record_data]}` - List of record data maps\n- `{:error, reason}` - Error reading records","ref":"Xbase.Parser.html#read_records/1-returns"},{"type":"function","title":"Examples - Xbase.Parser.read_records/1","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> {:ok, records} = Xbase.Parser.read_records(dbf)\n    iex> length(records)\n    10","ref":"Xbase.Parser.html#read_records/1-examples"},{"type":"function","title":"Xbase.Parser.record_statistics/1","doc":"Provides comprehensive statistics about records in the DBF file.","ref":"Xbase.Parser.html#record_statistics/1"},{"type":"function","title":"Parameters - Xbase.Parser.record_statistics/1","doc":"- `dbf` - DBF file structure from open_dbf/1","ref":"Xbase.Parser.html#record_statistics/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.record_statistics/1","doc":"- `{:ok, %{total_records: int, active_records: int, deleted_records: int, deletion_percentage: float}}` - Statistics\n- `{:error, reason}` - Error reading records","ref":"Xbase.Parser.html#record_statistics/1-returns"},{"type":"function","title":"Examples - Xbase.Parser.record_statistics/1","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> Xbase.Parser.record_statistics(dbf)\n    {:ok, %{total_records: 100, active_records: 85, deleted_records: 15, deletion_percentage: 15.0}}","ref":"Xbase.Parser.html#record_statistics/1-examples"},{"type":"function","title":"Xbase.Parser.refresh_dbf_state/1","doc":"Refreshes the DBF structure by re-reading the header and fields from file.","ref":"Xbase.Parser.html#refresh_dbf_state/1"},{"type":"function","title":"Parameters - Xbase.Parser.refresh_dbf_state/1","doc":"- `dbf` - DBF file structure from open_dbf/1","ref":"Xbase.Parser.html#refresh_dbf_state/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.refresh_dbf_state/1","doc":"- `{:ok, refreshed_dbf}` - DBF with updated header and fields\n- `{:error, reason}` - Error refreshing from file","ref":"Xbase.Parser.html#refresh_dbf_state/1-returns"},{"type":"function","title":"Examples - Xbase.Parser.refresh_dbf_state/1","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n    iex> Xbase.Parser.refresh_dbf_state(dbf)\n    {:ok, refreshed_dbf}","ref":"Xbase.Parser.html#refresh_dbf_state/1-examples"},{"type":"function","title":"Xbase.Parser.stream_records/1","doc":"Creates a lazy stream of records from the DBF file.","ref":"Xbase.Parser.html#stream_records/1"},{"type":"function","title":"Parameters - Xbase.Parser.stream_records/1","doc":"- `dbf` - DBF file structure from open_dbf/1","ref":"Xbase.Parser.html#stream_records/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.stream_records/1","doc":"- `Stream.t()` - Stream of record data maps (excludes deleted records)","ref":"Xbase.Parser.html#stream_records/1-returns"},{"type":"function","title":"Examples - Xbase.Parser.stream_records/1","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> stream = Xbase.Parser.stream_records(dbf)\n    iex> stream |> Enum.take(10) |> length()\n    10","ref":"Xbase.Parser.html#stream_records/1-examples"},{"type":"function","title":"Xbase.Parser.stream_records_with_progress/2","doc":"Creates a stream with progress reporting.","ref":"Xbase.Parser.html#stream_records_with_progress/2"},{"type":"function","title":"Parameters - Xbase.Parser.stream_records_with_progress/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `progress_fn` - Function called with progress info","ref":"Xbase.Parser.html#stream_records_with_progress/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.stream_records_with_progress/2","doc":"- `Stream.t()` - Stream of records with progress reporting","ref":"Xbase.Parser.html#stream_records_with_progress/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.stream_records_with_progress/2","doc":"progress_fn = fn prog -> send(self(), {:progress, prog}) end\n    records = Xbase.Parser.stream_records_with_progress(dbf, progress_fn) |> Enum.to_list()","ref":"Xbase.Parser.html#stream_records_with_progress/2-examples"},{"type":"function","title":"Xbase.Parser.stream_where/2","doc":"Creates a filtered stream of records from the DBF file.","ref":"Xbase.Parser.html#stream_where/2"},{"type":"function","title":"Parameters - Xbase.Parser.stream_where/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `filter_fn` - Function that takes record data and returns true/false","ref":"Xbase.Parser.html#stream_where/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.stream_where/2","doc":"- `Stream.t()` - Stream of filtered record data maps","ref":"Xbase.Parser.html#stream_where/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.stream_where/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> high_scores = fn record -> record[\"SCORE\"] > 90 end\n    iex> stream = Xbase.Parser.stream_where(dbf, high_scores)\n    iex> Enum.to_list(stream)\n    [%{\"SCORE\" => 95, ...}, ...]","ref":"Xbase.Parser.html#stream_where/2-examples"},{"type":"function","title":"Xbase.Parser.transaction/2","doc":"Executes a transaction function with rollback capability.","ref":"Xbase.Parser.html#transaction/2"},{"type":"function","title":"Parameters - Xbase.Parser.transaction/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `transaction_fn` - Function that takes a DBF and returns {:ok, updated_dbf} or {:error, reason}","ref":"Xbase.Parser.html#transaction/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.transaction/2","doc":"- `{:ok, final_dbf}` - Successfully committed transaction\n- `{:error, reason}` - Transaction failed and was rolled back","ref":"Xbase.Parser.html#transaction/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.transaction/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> {:ok, final_dbf} = Xbase.Parser.transaction(dbf, fn dbf ->\n    ...>   {:ok, dbf1} = Xbase.Parser.append_record(dbf, %{\"NAME\" => \"John\"})\n    ...>   {:ok, dbf2} = Xbase.Parser.update_record(dbf1, 0, %{\"STATUS\" => \"active\"})\n    ...>   {:ok, dbf2}\n    ...> end)","ref":"Xbase.Parser.html#transaction/2-examples"},{"type":"function","title":"Xbase.Parser.undelete_record/2","doc":"Undeletes a previously deleted record in the DBF file.","ref":"Xbase.Parser.html#undelete_record/2"},{"type":"function","title":"Parameters - Xbase.Parser.undelete_record/2","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `record_index` - Zero-based index of the record to undelete","ref":"Xbase.Parser.html#undelete_record/2-parameters"},{"type":"function","title":"Returns - Xbase.Parser.undelete_record/2","doc":"- `{:ok, updated_dbf}` - Successfully undeleted with updated DBF structure\n- `{:error, reason}` - Error undeleting record","ref":"Xbase.Parser.html#undelete_record/2-returns"},{"type":"function","title":"Examples - Xbase.Parser.undelete_record/2","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> {:ok, updated_dbf} = Xbase.Parser.undelete_record(dbf, 2)","ref":"Xbase.Parser.html#undelete_record/2-examples"},{"type":"function","title":"Xbase.Parser.update_record/3","doc":"Updates an existing record in the DBF file.","ref":"Xbase.Parser.html#update_record/3"},{"type":"function","title":"Parameters - Xbase.Parser.update_record/3","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `record_index` - Zero-based index of the record to update\n- `update_data` - Map of field name => value for fields to update","ref":"Xbase.Parser.html#update_record/3-parameters"},{"type":"function","title":"Returns - Xbase.Parser.update_record/3","doc":"- `{:ok, updated_dbf}` - Successfully updated with updated DBF structure\n- `{:error, reason}` - Error updating record","ref":"Xbase.Parser.html#update_record/3-returns"},{"type":"function","title":"Examples - Xbase.Parser.update_record/3","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n    iex> {:ok, updated_dbf} = Xbase.Parser.update_record(dbf, 0, %{\"NAME\" => \"Updated\", \"AGE\" => 40})","ref":"Xbase.Parser.html#update_record/3-examples"},{"type":"function","title":"Xbase.Parser.update_record_with_conflict_check/3","doc":"Updates a record with write conflict detection.","ref":"Xbase.Parser.html#update_record_with_conflict_check/3"},{"type":"function","title":"Parameters - Xbase.Parser.update_record_with_conflict_check/3","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `record_index` - Index of record to update\n- `update_data` - Map of field updates","ref":"Xbase.Parser.html#update_record_with_conflict_check/3-parameters"},{"type":"function","title":"Returns - Xbase.Parser.update_record_with_conflict_check/3","doc":"- `{:ok, updated_dbf}` - Successfully updated record\n- `{:error, :write_conflict}` - File was modified by another process\n- `{:error, reason}` - Other error during update","ref":"Xbase.Parser.html#update_record_with_conflict_check/3-returns"},{"type":"function","title":"Examples - Xbase.Parser.update_record_with_conflict_check/3","doc":"iex> {:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n    iex> Xbase.Parser.update_record_with_conflict_check(dbf, 0, %{\"NAME\" => \"John\"})\n    {:ok, updated_dbf}","ref":"Xbase.Parser.html#update_record_with_conflict_check/3-examples"},{"type":"function","title":"Xbase.Parser.update_record_with_retry/3","doc":"Updates a record with automatic retry on conflict detection.\n\nThis function automatically refreshes the DBF state if a write conflict\nis detected and retries the operation once.","ref":"Xbase.Parser.html#update_record_with_retry/3"},{"type":"function","title":"Parameters - Xbase.Parser.update_record_with_retry/3","doc":"- `dbf` - DBF file structure from open_dbf/1\n- `record_index` - Index of record to update\n- `update_data` - Map of field updates","ref":"Xbase.Parser.html#update_record_with_retry/3-parameters"},{"type":"function","title":"Returns - Xbase.Parser.update_record_with_retry/3","doc":"- `{:ok, updated_dbf}` - Successfully updated record\n- `{:error, reason}` - Error during update (after retry if conflict occurred)","ref":"Xbase.Parser.html#update_record_with_retry/3-returns"},{"type":"function","title":"Xbase.Parser.validate_header_consistency/1","doc":"Validates header consistency after write operations.","ref":"Xbase.Parser.html#validate_header_consistency/1"},{"type":"function","title":"Parameters - Xbase.Parser.validate_header_consistency/1","doc":"- `dbf` - DBF file structure","ref":"Xbase.Parser.html#validate_header_consistency/1-parameters"},{"type":"function","title":"Returns - Xbase.Parser.validate_header_consistency/1","doc":"- `:ok` - Header is consistent\n- `{:error, reason}` - Header inconsistency detected","ref":"Xbase.Parser.html#validate_header_consistency/1-returns"},{"type":"function","title":"Xbase.Parser.write_header/2","doc":"","ref":"Xbase.Parser.html#write_header/2"},{"type":"module","title":"Xbase.Types","doc":"Data structures for DBF file format components.","ref":"Xbase.Types.html"},{"type":"module","title":"Xbase.DbtParser","doc":"Parser for DBT (memo) files used in dBase for storing variable-length text data.\n\nDBT files store memo field content in a block-based structure with a 512-byte header\nfollowed by fixed-size blocks containing memo data terminated by 0x1A 0x1A markers.","ref":"Xbase.DbtParser.html"},{"type":"function","title":"Xbase.DbtParser.calculate_block_offset/2","doc":"Calculates the byte offset for a specific block number.","ref":"Xbase.DbtParser.html#calculate_block_offset/2"},{"type":"function","title":"Parameters - Xbase.DbtParser.calculate_block_offset/2","doc":"- `header` - DbtHeader structure\n- `block_number` - Block number to calculate offset for","ref":"Xbase.DbtParser.html#calculate_block_offset/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtParser.calculate_block_offset/2","doc":"- Integer byte offset from start of file","ref":"Xbase.DbtParser.html#calculate_block_offset/2-returns"},{"type":"function","title":"Xbase.DbtParser.close_dbt/1","doc":"Closes a DBT file handle.","ref":"Xbase.DbtParser.html#close_dbt/1"},{"type":"function","title":"Parameters - Xbase.DbtParser.close_dbt/1","doc":"- `dbt_file` - DbtFile structure from open_dbt/1","ref":"Xbase.DbtParser.html#close_dbt/1-parameters"},{"type":"function","title":"Returns - Xbase.DbtParser.close_dbt/1","doc":"- `:ok` - File closed successfully","ref":"Xbase.DbtParser.html#close_dbt/1-returns"},{"type":"function","title":"Xbase.DbtParser.extract_memo_content/1","doc":"Extracts memo content from a block, handling termination markers.","ref":"Xbase.DbtParser.html#extract_memo_content/1"},{"type":"function","title":"Parameters - Xbase.DbtParser.extract_memo_content/1","doc":"- `block_data` - Binary data from a memo block","ref":"Xbase.DbtParser.html#extract_memo_content/1-parameters"},{"type":"function","title":"Returns - Xbase.DbtParser.extract_memo_content/1","doc":"- `{:ok, String.t()}` - Extracted memo content\n- `{:error, reason}` - Error extracting content","ref":"Xbase.DbtParser.html#extract_memo_content/1-returns"},{"type":"function","title":"Xbase.DbtParser.open_dbt/2","doc":"Opens a DBT file and parses its header.","ref":"Xbase.DbtParser.html#open_dbt/2"},{"type":"function","title":"Parameters - Xbase.DbtParser.open_dbt/2","doc":"- `file_path` - Path to the DBT file\n- `version` - DBT format version (optional)","ref":"Xbase.DbtParser.html#open_dbt/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtParser.open_dbt/2","doc":"- `{:ok, DbtFile.t()}` - Successfully opened DBT file\n- `{:error, reason}` - Error opening or parsing file","ref":"Xbase.DbtParser.html#open_dbt/2-returns"},{"type":"function","title":"Xbase.DbtParser.parse_header/2","doc":"Parses a DBT file header from binary data.","ref":"Xbase.DbtParser.html#parse_header/2"},{"type":"function","title":"Parameters - Xbase.DbtParser.parse_header/2","doc":"- `header_binary` - 512 bytes of header data\n- `version` - DBT format version (defaults to :dbase_iii)","ref":"Xbase.DbtParser.html#parse_header/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtParser.parse_header/2","doc":"- `{:ok, DbtHeader.t()}` - Successfully parsed header\n- `{:error, reason}` - Error parsing header","ref":"Xbase.DbtParser.html#parse_header/2-returns"},{"type":"function","title":"Xbase.DbtParser.read_memo/2","doc":"Reads memo content from a specific block number.","ref":"Xbase.DbtParser.html#read_memo/2"},{"type":"function","title":"Parameters - Xbase.DbtParser.read_memo/2","doc":"- `dbt_file` - DbtFile structure from open_dbt/1\n- `block_number` - Block number to read (1-based, 0 is header)","ref":"Xbase.DbtParser.html#read_memo/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtParser.read_memo/2","doc":"- `{:ok, String.t()}` - Memo content\n- `{:error, reason}` - Error reading block","ref":"Xbase.DbtParser.html#read_memo/2-returns"},{"type":"function","title":"Xbase.DbtParser.validate_dbt_file/1","doc":"Validates a DBT file for basic integrity.","ref":"Xbase.DbtParser.html#validate_dbt_file/1"},{"type":"function","title":"Parameters - Xbase.DbtParser.validate_dbt_file/1","doc":"- `file_path` - Path to the DBT file to validate","ref":"Xbase.DbtParser.html#validate_dbt_file/1-parameters"},{"type":"function","title":"Returns - Xbase.DbtParser.validate_dbt_file/1","doc":"- `{:ok, boolean()}` - Validation result\n- `{:error, reason}` - Error during validation","ref":"Xbase.DbtParser.html#validate_dbt_file/1-returns"},{"type":"module","title":"Xbase.DbtWriter","doc":"Module for writing and managing memo content in DBT files.\n\nProvides comprehensive memo writing capabilities including append, update,\ndeletion, block management, and file compaction. Coordinates with DBF\nrecord operations to maintain consistency.","ref":"Xbase.DbtWriter.html"},{"type":"function","title":"Xbase.DbtWriter.analyze_fragmentation/1","doc":"Analyzes DBT file fragmentation and returns statistics.","ref":"Xbase.DbtWriter.html#analyze_fragmentation/1"},{"type":"function","title":"Parameters - Xbase.DbtWriter.analyze_fragmentation/1","doc":"- `dbt_file` - DbtFile structure","ref":"Xbase.DbtWriter.html#analyze_fragmentation/1-parameters"},{"type":"function","title":"Returns - Xbase.DbtWriter.analyze_fragmentation/1","doc":"- `{:ok, %{total_blocks: n, used_blocks: n, free_blocks: n, fragmentation_ratio: f}}`\n- `{:error, reason}` - Error analyzing file","ref":"Xbase.DbtWriter.html#analyze_fragmentation/1-returns"},{"type":"function","title":"Xbase.DbtWriter.close_dbt/1","doc":"Closes a DBT file opened for writing.","ref":"Xbase.DbtWriter.html#close_dbt/1"},{"type":"function","title":"Parameters - Xbase.DbtWriter.close_dbt/1","doc":"- `dbt_file` - DbtFile structure","ref":"Xbase.DbtWriter.html#close_dbt/1-parameters"},{"type":"function","title":"Returns - Xbase.DbtWriter.close_dbt/1","doc":"- `:ok` - File closed successfully","ref":"Xbase.DbtWriter.html#close_dbt/1-returns"},{"type":"function","title":"Xbase.DbtWriter.compact_dbt/2","doc":"Compacts a DBT file by removing unused blocks and rebuilding the file.","ref":"Xbase.DbtWriter.html#compact_dbt/2"},{"type":"function","title":"Parameters - Xbase.DbtWriter.compact_dbt/2","doc":"- `dbt_file` - DbtFile structure to compact\n- `output_path` - Path for the compacted file (can be same as input)","ref":"Xbase.DbtWriter.html#compact_dbt/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtWriter.compact_dbt/2","doc":"- `{:ok, compacted_dbt_file}` - Successfully compacted DBT file\n- `{:error, reason}` - Error during compaction","ref":"Xbase.DbtWriter.html#compact_dbt/2-returns"},{"type":"function","title":"Xbase.DbtWriter.create_dbt/2","doc":"Creates a new DBT file with initial header.","ref":"Xbase.DbtWriter.html#create_dbt/2"},{"type":"function","title":"Parameters - Xbase.DbtWriter.create_dbt/2","doc":"- `file_path` - Path for the new DBT file\n- `opts` - Options for DBT creation\n  - `:version` - DBT format version (default: :dbase_iii)\n  - `:block_size` - Block size in bytes (default: 512)","ref":"Xbase.DbtWriter.html#create_dbt/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtWriter.create_dbt/2","doc":"- `{:ok, DbtFile.t()}` - Successfully created DBT file\n- `{:error, reason}` - Error creating file","ref":"Xbase.DbtWriter.html#create_dbt/2-returns"},{"type":"function","title":"Xbase.DbtWriter.delete_memo/2","doc":"Marks a memo block as deleted by writing empty content.","ref":"Xbase.DbtWriter.html#delete_memo/2"},{"type":"function","title":"Parameters - Xbase.DbtWriter.delete_memo/2","doc":"- `dbt_file` - DbtFile structure opened for writing\n- `block_number` - Block number to delete","ref":"Xbase.DbtWriter.html#delete_memo/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtWriter.delete_memo/2","doc":"- `{:ok, dbt_file}` - Successfully deleted memo\n- `{:error, reason}` - Error deleting memo","ref":"Xbase.DbtWriter.html#delete_memo/2-returns"},{"type":"function","title":"Xbase.DbtWriter.open_dbt_for_writing/2","doc":"Opens a DBT file for writing operations.","ref":"Xbase.DbtWriter.html#open_dbt_for_writing/2"},{"type":"function","title":"Parameters - Xbase.DbtWriter.open_dbt_for_writing/2","doc":"- `file_path` - Path to the DBT file\n- `version` - DBT format version (optional, defaults to :dbase_iii)","ref":"Xbase.DbtWriter.html#open_dbt_for_writing/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtWriter.open_dbt_for_writing/2","doc":"- `{:ok, DbtFile.t()}` - Successfully opened DBT file for writing\n- `{:error, reason}` - Error opening file","ref":"Xbase.DbtWriter.html#open_dbt_for_writing/2-returns"},{"type":"function","title":"Xbase.DbtWriter.update_memo/3","doc":"Updates existing memo content at a specific block.","ref":"Xbase.DbtWriter.html#update_memo/3"},{"type":"function","title":"Parameters - Xbase.DbtWriter.update_memo/3","doc":"- `dbt_file` - DbtFile structure opened for writing\n- `block_number` - Block number to update\n- `content` - New memo content (string)","ref":"Xbase.DbtWriter.html#update_memo/3-parameters"},{"type":"function","title":"Returns - Xbase.DbtWriter.update_memo/3","doc":"- `{:ok, dbt_file}` - Successfully updated memo\n- `{:error, reason}` - Error updating memo","ref":"Xbase.DbtWriter.html#update_memo/3-returns"},{"type":"function","title":"Xbase.DbtWriter.write_memo/2","doc":"Writes new memo content to the DBT file and returns the block number.","ref":"Xbase.DbtWriter.html#write_memo/2"},{"type":"function","title":"Parameters - Xbase.DbtWriter.write_memo/2","doc":"- `dbt_file` - DbtFile structure opened for writing\n- `content` - Memo content to write (string)","ref":"Xbase.DbtWriter.html#write_memo/2-parameters"},{"type":"function","title":"Returns - Xbase.DbtWriter.write_memo/2","doc":"- `{:ok, {block_number, updated_dbt_file}}` - Successfully written memo\n- `{:error, reason}` - Error writing memo","ref":"Xbase.DbtWriter.html#write_memo/2-returns"},{"type":"module","title":"Xbase.MemoHandler","doc":"Handles coordinated operations between DBF and DBT files for memo field support.\n\nProvides high-level API for seamless memo content handling in record operations,\nautomatic file discovery, and transaction safety across both file types.","ref":"Xbase.MemoHandler.html"},{"type":"function","title":"Xbase.MemoHandler.append_record_with_memo/2","doc":"Appends a record with automatic memo content handling.","ref":"Xbase.MemoHandler.html#append_record_with_memo/2"},{"type":"function","title":"Parameters - Xbase.MemoHandler.append_record_with_memo/2","doc":"- `handler` - MemoHandler structure\n- `record_data` - Map of field names to values, where memo fields contain content strings","ref":"Xbase.MemoHandler.html#append_record_with_memo/2-parameters"},{"type":"function","title":"Returns - Xbase.MemoHandler.append_record_with_memo/2","doc":"- `{:ok, updated_handler}` - Successfully appended record with memo content\n- `{:error, reason}` - Error appending record","ref":"Xbase.MemoHandler.html#append_record_with_memo/2-returns"},{"type":"function","title":"Example - Xbase.MemoHandler.append_record_with_memo/2","doc":"record_data = %{\n      \"NAME\" => \"John Doe\",\n      \"NOTES\" => \"This memo content will be automatically stored in the DBT file\"\n    }\n    {:ok, updated_handler} = MemoHandler.append_record_with_memo(handler, record_data)","ref":"Xbase.MemoHandler.html#append_record_with_memo/2-example"},{"type":"function","title":"Xbase.MemoHandler.close_memo_files/1","doc":"Closes both DBF and DBT files properly.","ref":"Xbase.MemoHandler.html#close_memo_files/1"},{"type":"function","title":"Parameters - Xbase.MemoHandler.close_memo_files/1","doc":"- `handler` - MemoHandler structure","ref":"Xbase.MemoHandler.html#close_memo_files/1-parameters"},{"type":"function","title":"Returns - Xbase.MemoHandler.close_memo_files/1","doc":"- `:ok` - Files closed successfully","ref":"Xbase.MemoHandler.html#close_memo_files/1-returns"},{"type":"function","title":"Xbase.MemoHandler.create_dbf_with_memo/3","doc":"Creates a new DBF file with memo support and coordinated DBT file.","ref":"Xbase.MemoHandler.html#create_dbf_with_memo/3"},{"type":"function","title":"Parameters - Xbase.MemoHandler.create_dbf_with_memo/3","doc":"- `dbf_path` - Path for the new DBF file\n- `fields` - Field definitions for the DBF file\n- `opts` - Options for file creation\n  - `:version` - DBF version (automatically set to memo-capable if memo fields present)\n  - `:dbt_path` - Explicit DBT file path (defaults to replacing .dbf with .dbt)\n  - `:block_size` - DBT block size (default: 512)","ref":"Xbase.MemoHandler.html#create_dbf_with_memo/3-parameters"},{"type":"function","title":"Returns - Xbase.MemoHandler.create_dbf_with_memo/3","doc":"- `{:ok, MemoHandler.t()}` - Successfully created coordinated files\n- `{:error, reason}` - Error creating files","ref":"Xbase.MemoHandler.html#create_dbf_with_memo/3-returns"},{"type":"function","title":"Xbase.MemoHandler.memo_transaction/2","doc":"Executes a function with transaction safety across both DBF and DBT files.","ref":"Xbase.MemoHandler.html#memo_transaction/2"},{"type":"function","title":"Parameters - Xbase.MemoHandler.memo_transaction/2","doc":"- `handler` - MemoHandler structure\n- `transaction_fn` - Function to execute with the handler","ref":"Xbase.MemoHandler.html#memo_transaction/2-parameters"},{"type":"function","title":"Returns - Xbase.MemoHandler.memo_transaction/2","doc":"- `{:ok, {result, updated_handler}}` - Transaction successful\n- `{:error, reason}` - Transaction failed, changes rolled back","ref":"Xbase.MemoHandler.html#memo_transaction/2-returns"},{"type":"function","title":"Xbase.MemoHandler.open_dbf_with_memo/3","doc":"Opens a DBF file with automatic memo file discovery and coordination.","ref":"Xbase.MemoHandler.html#open_dbf_with_memo/3"},{"type":"function","title":"Parameters - Xbase.MemoHandler.open_dbf_with_memo/3","doc":"- `dbf_path` - Path to the DBF file\n- `modes` - File access modes (default: [:read])\n- `opts` - Options for memo handling\n  - `:memo` - Memo mode (:auto, :required, :disabled)\n  - `:dbt_path` - Explicit DBT file path (overrides auto-discovery)","ref":"Xbase.MemoHandler.html#open_dbf_with_memo/3-parameters"},{"type":"function","title":"Returns - Xbase.MemoHandler.open_dbf_with_memo/3","doc":"- `{:ok, MemoHandler.t()}` - Successfully opened coordinated files\n- `{:error, reason}` - Error opening files","ref":"Xbase.MemoHandler.html#open_dbf_with_memo/3-returns"},{"type":"function","title":"Examples - Xbase.MemoHandler.open_dbf_with_memo/3","doc":"# Automatic memo file discovery\n    {:ok, handler} = MemoHandler.open_dbf_with_memo(\"data.dbf\")\n    \n    # Read-write mode with required memo support\n    {:ok, handler} = MemoHandler.open_dbf_with_memo(\"data.dbf\", [:read, :write], memo: :required)\n    \n    # Explicit DBT file path\n    {:ok, handler} = MemoHandler.open_dbf_with_memo(\"data.dbf\", [], dbt_path: \"memos.dbt\")","ref":"Xbase.MemoHandler.html#open_dbf_with_memo/3-examples"},{"type":"function","title":"Xbase.MemoHandler.read_record_with_memo/2","doc":"Reads a record with automatic memo content resolution.","ref":"Xbase.MemoHandler.html#read_record_with_memo/2"},{"type":"function","title":"Parameters - Xbase.MemoHandler.read_record_with_memo/2","doc":"- `handler` - MemoHandler structure\n- `record_index` - Zero-based record index to read","ref":"Xbase.MemoHandler.html#read_record_with_memo/2-parameters"},{"type":"function","title":"Returns - Xbase.MemoHandler.read_record_with_memo/2","doc":"- `{:ok, record_data}` - Record data with memo content resolved\n- `{:error, reason}` - Error reading record","ref":"Xbase.MemoHandler.html#read_record_with_memo/2-returns"},{"type":"type","title":"Xbase.MemoHandler.t/0","doc":"","ref":"Xbase.MemoHandler.html#t:t/0"},{"type":"function","title":"Xbase.MemoHandler.update_record_with_memo/3","doc":"Updates a record with automatic memo content handling.","ref":"Xbase.MemoHandler.html#update_record_with_memo/3"},{"type":"function","title":"Parameters - Xbase.MemoHandler.update_record_with_memo/3","doc":"- `handler` - MemoHandler structure\n- `record_index` - Zero-based record index to update\n- `record_data` - Map of field names to values for update","ref":"Xbase.MemoHandler.html#update_record_with_memo/3-parameters"},{"type":"function","title":"Returns - Xbase.MemoHandler.update_record_with_memo/3","doc":"- `{:ok, updated_handler}` - Successfully updated record with memo content\n- `{:error, reason}` - Error updating record","ref":"Xbase.MemoHandler.html#update_record_with_memo/3-returns"},{"type":"module","title":"Xbase.FieldEncoder","doc":"Field encoder for DBF data types.\n\nThis module provides encoding functionality for different DBF field types,\nconverting Elixir values to binary data based on field descriptors.\nThis is the reverse operation of Xbase.FieldParser.","ref":"Xbase.FieldEncoder.html"},{"type":"function","title":"Xbase.FieldEncoder.encode/2","doc":"Encodes a value to binary field data based on the field descriptor.","ref":"Xbase.FieldEncoder.html#encode/2"},{"type":"function","title":"Parameters - Xbase.FieldEncoder.encode/2","doc":"- `field_desc` - The field descriptor containing type and length information\n- `value` - The Elixir value to encode","ref":"Xbase.FieldEncoder.html#encode/2-parameters"},{"type":"function","title":"Returns - Xbase.FieldEncoder.encode/2","doc":"- `{:ok, binary_data}` - Successfully encoded binary\n- `{:error, reason}` - Encoding error with reason","ref":"Xbase.FieldEncoder.html#encode/2-returns"},{"type":"function","title":"Examples - Xbase.FieldEncoder.encode/2","doc":"iex> field_desc = %FieldDescriptor{type: \"C\", length: 10}\n    iex> Xbase.FieldEncoder.encode(field_desc, \"John Doe\")\n    {:ok, \"John Doe  \"}","ref":"Xbase.FieldEncoder.html#encode/2-examples"},{"type":"module","title":"Xbase.FieldParser","doc":"Field parser for DBF data types.\n\nThis module provides parsing functionality for different DBF field types,\nconverting binary data to appropriate Elixir types based on field descriptors.","ref":"Xbase.FieldParser.html"},{"type":"function","title":"Xbase.FieldParser.parse/2","doc":"Parses field data based on the field descriptor.","ref":"Xbase.FieldParser.html#parse/2"},{"type":"function","title":"Parameters - Xbase.FieldParser.parse/2","doc":"- `field_desc` - The field descriptor containing type and length information\n- `binary_data` - The raw binary data for this field","ref":"Xbase.FieldParser.html#parse/2-parameters"},{"type":"function","title":"Returns - Xbase.FieldParser.parse/2","doc":"- `{:ok, parsed_value}` - Successfully parsed value\n- `{:error, reason}` - Parse error with reason","ref":"Xbase.FieldParser.html#parse/2-returns"},{"type":"function","title":"Examples - Xbase.FieldParser.parse/2","doc":"iex> field_desc = %FieldDescriptor{type: \"C\", length: 10}\n    iex> Xbase.FieldParser.parse(field_desc, \"John Doe  \")\n    {:ok, \"John Doe\"}","ref":"Xbase.FieldParser.html#parse/2-examples"},{"type":"module","title":"Xbase.CdxParser","doc":"Parser for CDX (compound index) files used in dBase for fast data access.\n\nCDX files implement a B-tree structure with 512-byte pages containing root,\nbranch, and leaf nodes. The file begins with a header containing metadata\nabout the index structure and key expressions.","ref":"Xbase.CdxParser.html"},{"type":"function","title":"Xbase.CdxParser.close_cdx/1","doc":"Closes a CDX file handle and cleans up resources.","ref":"Xbase.CdxParser.html#close_cdx/1"},{"type":"function","title":"Parameters - Xbase.CdxParser.close_cdx/1","doc":"- `cdx_file` - CdxFile structure from open_cdx/1","ref":"Xbase.CdxParser.html#close_cdx/1-parameters"},{"type":"function","title":"Returns - Xbase.CdxParser.close_cdx/1","doc":"- `:ok` - File closed successfully","ref":"Xbase.CdxParser.html#close_cdx/1-returns"},{"type":"function","title":"Xbase.CdxParser.open_cdx/1","doc":"Opens a CDX file and parses its header.","ref":"Xbase.CdxParser.html#open_cdx/1"},{"type":"function","title":"Parameters - Xbase.CdxParser.open_cdx/1","doc":"- `file_path` - Path to the CDX file","ref":"Xbase.CdxParser.html#open_cdx/1-parameters"},{"type":"function","title":"Returns - Xbase.CdxParser.open_cdx/1","doc":"- `{:ok, CdxFile.t()}` - Successfully opened CDX file\n- `{:error, reason}` - Error opening or parsing file","ref":"Xbase.CdxParser.html#open_cdx/1-returns"},{"type":"function","title":"Xbase.CdxParser.parse_header/1","doc":"Parses a CDX file header from binary data.","ref":"Xbase.CdxParser.html#parse_header/1"},{"type":"function","title":"Parameters - Xbase.CdxParser.parse_header/1","doc":"- `header_binary` - 512 bytes of header data","ref":"Xbase.CdxParser.html#parse_header/1-parameters"},{"type":"function","title":"Returns - Xbase.CdxParser.parse_header/1","doc":"- `{:ok, CdxHeader.t()}` - Successfully parsed header\n- `{:error, reason}` - Error parsing header","ref":"Xbase.CdxParser.html#parse_header/1-returns"},{"type":"function","title":"Xbase.CdxParser.parse_node/2","doc":"Parses a CDX B-tree node from binary page data.","ref":"Xbase.CdxParser.html#parse_node/2"},{"type":"function","title":"Parameters - Xbase.CdxParser.parse_node/2","doc":"- `page_data` - 512 bytes of page data\n- `key_length` - Length of keys in this index","ref":"Xbase.CdxParser.html#parse_node/2-parameters"},{"type":"function","title":"Returns - Xbase.CdxParser.parse_node/2","doc":"- `{:ok, CdxNode.t()}` - Successfully parsed node\n- `{:error, reason}` - Error parsing node","ref":"Xbase.CdxParser.html#parse_node/2-returns"},{"type":"function","title":"Xbase.CdxParser.read_node/2","doc":"Reads a B-tree node from a specific page number.","ref":"Xbase.CdxParser.html#read_node/2"},{"type":"function","title":"Parameters - Xbase.CdxParser.read_node/2","doc":"- `cdx_file` - CdxFile structure from open_cdx/1\n- `page_number` - Page number to read (0-based)","ref":"Xbase.CdxParser.html#read_node/2-parameters"},{"type":"function","title":"Returns - Xbase.CdxParser.read_node/2","doc":"- `{:ok, CdxNode.t()}` - Successfully read node\n- `{:error, reason}` - Error reading node","ref":"Xbase.CdxParser.html#read_node/2-returns"},{"type":"function","title":"Xbase.CdxParser.search_key/2","doc":"Searches for a key in the B-tree starting from the root node.","ref":"Xbase.CdxParser.html#search_key/2"},{"type":"function","title":"Parameters - Xbase.CdxParser.search_key/2","doc":"- `cdx_file` - CdxFile structure\n- `search_key` - Key to search for","ref":"Xbase.CdxParser.html#search_key/2-parameters"},{"type":"function","title":"Returns - Xbase.CdxParser.search_key/2","doc":"- `{:ok, record_number}` - Found key, returns record number\n- `{:error, :not_found}` - Key not found\n- `{:error, reason}` - Error during search","ref":"Xbase.CdxParser.html#search_key/2-returns"},{"type":"extras","title":"Xbase","doc":"# Xbase\n\n[![Hex.pm](https://img.shields.io/hexpm/v/xbase.svg)](https://hex.pm/packages/xbase)\n[![Documentation](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/xbase/)\n[![License](https://img.shields.io/hexpm/l/xbase.svg)](https://github.com/your-org/xbase/blob/main/LICENSE)\n\nA comprehensive, production-ready Elixir library for reading, writing, and manipulating dBase database files (DBF) with full support for memo fields (DBT) and indexes (CDX).\n\nBuilt for performance, reliability, and ease of use, Xbase provides a complete solution for working with legacy dBase files in modern Elixir applications.","ref":"readme.html"},{"type":"extras","title":"✨ Features - Xbase","doc":"","ref":"readme.html#features"},{"type":"extras","title":"🗃️ Complete dBase Support - Xbase","doc":"- **File Formats**: dBase III, IV, 5, FoxPro, and Visual FoxPro compatibility\n- **Field Types**: Character (C), Numeric (N), Date (D), Logical (L), and Memo (M)\n- **File Operations**: Create, read, update, delete, and pack operations\n- **Binary Parsing**: High-performance binary pattern matching","ref":"readme.html#complete-dbase-support"},{"type":"extras","title":"📝 Advanced Memo Fields - Xbase","doc":"- **DBT Integration**: Seamless variable-length text storage\n- **Smart Caching**: Built-in memo block caching for performance\n- **Transaction Safety**: ACID-compliant memo operations\n- **Content Management**: Automatic block allocation and compaction","ref":"readme.html#advanced-memo-fields"},{"type":"extras","title":"🚀 Performance & Scalability - Xbase","doc":"- **Memory Efficient**: Stream-based processing for large files\n- **Lazy Evaluation**: On-demand data loading\n- **Batch Operations**: Optimized bulk operations\n- **Index Support**: B-tree CDX indexes for fast lookups","ref":"readme.html#performance-scalability"},{"type":"extras","title":"🔐 Enterprise Ready - Xbase","doc":"- **Transaction Safety**: Full ACID compliance with rollback support\n- **Error Handling**: Comprehensive error reporting and recovery\n- **Resource Management**: Proper file handle lifecycle management\n- **Production Tested**: Built for reliability and performance","ref":"readme.html#enterprise-ready"},{"type":"extras","title":"📦 Installation - Xbase","doc":"Add `xbase` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:xbase, \"~> 0.1.0\"}\n  ]\nend\n```\n\nThen run:\n```bash\nmix deps.get\n```","ref":"readme.html#installation"},{"type":"extras","title":"🚀 Quick Start - Xbase","doc":"","ref":"readme.html#quick-start"},{"type":"extras","title":"Reading DBF Files - Xbase","doc":"```elixir\n# Open a DBF file\n{:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n\n# Read a single record\n{:ok, record} = Xbase.Parser.read_record(dbf, 0)\n# => %Xbase.Types.Record{data: %{\"NAME\" => \"John Doe\", \"AGE\" => 30}, deleted: false}\n\n# Read all records\n{:ok, records} = Xbase.Parser.read_records(dbf)\n\n# Stream records for memory efficiency\ndbf\n|> Xbase.Parser.stream_records()\n|> Stream.filter(fn record -> record.data[\"AGE\"] > 25 end)\n|> Enum.to_list()\n\n# Don't forget to close\nXbase.Parser.close_dbf(dbf)\n```","ref":"readme.html#reading-dbf-files"},{"type":"extras","title":"Writing DBF Files - Xbase","doc":"```elixir\n# Define field structure\nfields = [\n  %Xbase.Types.FieldDescriptor{name: \"NAME\", type: \"C\", length: 30},\n  %Xbase.Types.FieldDescriptor{name: \"AGE\", type: \"N\", length: 3, decimal_count: 0},\n  %Xbase.Types.FieldDescriptor{name: \"BIRTHDATE\", type: \"D\", length: 8},\n  %Xbase.Types.FieldDescriptor{name: \"ACTIVE\", type: \"L\", length: 1}\n]\n\n# Create new DBF file\n{:ok, dbf} = Xbase.Parser.create_dbf(\"output.dbf\", fields)\n\n# Append records\n{:ok, dbf} = Xbase.Parser.append_record(dbf, %{\n  \"NAME\" => \"Jane Smith\",\n  \"AGE\" => 28,\n  \"BIRTHDATE\" => ~D[1995-03-15],\n  \"ACTIVE\" => true\n})\n\n# Update existing record\n{:ok, dbf} = Xbase.Parser.update_record(dbf, 0, %{\"AGE\" => 29})\n\n# Mark record as deleted\n{:ok, dbf} = Xbase.Parser.mark_deleted(dbf, 0)\n\n# Pack file to remove deleted records\n{:ok, dbf} = Xbase.Parser.pack(dbf, \"packed.dbf\")\n\nXbase.Parser.close_dbf(dbf)\n```","ref":"readme.html#writing-dbf-files"},{"type":"extras","title":"Working with Memo Fields - Xbase","doc":"```elixir\n# Using MemoHandler for seamless memo support\n{:ok, handler} = Xbase.MemoHandler.open_dbf_with_memo(\"data.dbf\", [:read, :write])\n\n# Append record with memo content\n{:ok, handler} = Xbase.MemoHandler.append_record_with_memo(handler, %{\n  \"NAME\" => \"John Doe\",\n  \"NOTES\" => \"This is a long memo that will be stored in the DBT file automatically\"\n})\n\n# Read record with resolved memo content\n{:ok, record} = Xbase.MemoHandler.read_record_with_memo(handler, 0)\n# => %{\"NAME\" => \"John Doe\", \"NOTES\" => \"This is a long memo...\"}\n\n# Update memo content\n{:ok, handler} = Xbase.MemoHandler.update_record_with_memo(handler, 0, %{\n  \"NOTES\" => \"Updated memo content\"\n})\n\nXbase.MemoHandler.close_memo_files(handler)\n```","ref":"readme.html#working-with-memo-fields"},{"type":"extras","title":"Using Indexes - Xbase","doc":"```elixir\n# Open DBF with index\n{:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\")\n{:ok, cdx} = Xbase.CdxParser.open_cdx(\"data.cdx\")\n\n# Search using index\n{:ok, key_info} = Xbase.CdxParser.search_key(cdx, \"SMITH\")\n# => Returns record number for fast access\n\n# Range queries\nkeys = Xbase.CdxParser.search_range(cdx, \"A\", \"M\")\n\nXbase.CdxParser.close_cdx(cdx)\n```","ref":"readme.html#using-indexes"},{"type":"extras","title":"Transactions - Xbase","doc":"```elixir\n# Wrap operations in a transaction\n{:ok, result} = Xbase.Parser.with_transaction(dbf, fn dbf ->\n  {:ok, dbf} = Xbase.Parser.append_record(dbf, record1)\n  {:ok, dbf} = Xbase.Parser.append_record(dbf, record2)\n  {:ok, dbf} = Xbase.Parser.update_record(dbf, 0, updates)\n  {:ok, :success}\nend)\n# Automatically rolls back on error\n```","ref":"readme.html#transactions"},{"type":"extras","title":"Batch Operations - Xbase","doc":"```elixir\n# Batch append for performance\nrecords = [record1, record2, record3, ...]\n{:ok, dbf} = Xbase.Parser.batch_append_records(dbf, records)\n\n# Batch update\nupdates = [{0, %{\"STATUS\" => \"ACTIVE\"}}, {1, %{\"STATUS\" => \"INACTIVE\"}}]\n{:ok, dbf} = Xbase.Parser.batch_update_records(dbf, updates)\n\n# Batch delete\n{:ok, dbf} = Xbase.Parser.batch_delete(dbf, [5, 10, 15])\n```","ref":"readme.html#batch-operations"},{"type":"extras","title":"📚 Documentation - Xbase","doc":"","ref":"readme.html#documentation"},{"type":"extras","title":"Complete Guides - Xbase","doc":"- **[Getting Started Guide](https://hexdocs.pm/xbase/getting_started.html)** - Your first steps with Xbase\n- **[Working with Memo Fields](https://hexdocs.pm/xbase/memo_fields.html)** - Complete memo field guide\n- **[API Reference](https://hexdocs.pm/xbase/api-reference.html)** - Full API documentation","ref":"readme.html#complete-guides"},{"type":"extras","title":"Core Modules - Xbase","doc":"| Module | Purpose |\n|--------|---------|\n| `Xbase.Parser` | Main DBF file operations (create, read, write, update) |\n| `Xbase.MemoHandler` | High-level memo field integration and transactions |\n| `Xbase.Types` | Data structures and type definitions |\n| `Xbase.FieldParser` | Field type parsing and validation |\n| `Xbase.FieldEncoder` | Field type encoding and formatting |\n| `Xbase.CdxParser` | Index file support for fast lookups |\n| `Xbase.DbtParser` | Low-level DBT memo file reading |\n| `Xbase.DbtWriter` | DBT memo file writing and management |","ref":"readme.html#core-modules"},{"type":"extras","title":"⚡ Performance - Xbase","doc":"","ref":"readme.html#performance"},{"type":"extras","title":"Benchmarks - Xbase","doc":"| Operation | Records | Time | Memory |\n|-----------|---------|------|---------|\n| Stream read | 1M records | ~2.5s | ~50MB |\n| Batch append | 100K records | ~1.2s | ~25MB |\n| Index search | 1M records | ~0.01s | ~10MB |\n| Memo access | 10K memos | ~0.8s | ~15MB |","ref":"readme.html#benchmarks"},{"type":"extras","title":"Optimization Tips - Xbase","doc":"- **Large Files**: Use `stream_records/1` for memory-efficient processing\n- **Bulk Operations**: Leverage batch functions (`batch_append_records`, `batch_update_records`)\n- **Fast Lookups**: Create CDX indexes for frequently searched fields\n- **Memo Performance**: Built-in caching optimizes repeated memo access\n- **Transactions**: Group related operations for better performance and safety","ref":"readme.html#optimization-tips"},{"type":"extras","title":"🛡️ Error Handling - Xbase","doc":"Xbase follows Elixir conventions with comprehensive error handling:\n\n```elixir\ncase Xbase.Parser.open_dbf(\"data.dbf\") do\n  {:ok, dbf} ->\n    # Work with the file safely\n    process_records(dbf)\n  {:error, :enoent} ->\n    {:error, \"File not found: please check the file path\"}\n  {:error, :invalid_dbf_header} ->\n    {:error, \"Invalid DBF file format\"}\n  {:error, reason} ->\n    {:error, \"Unexpected error: #{inspect(reason)}\"}\nend\n```","ref":"readme.html#error-handling"},{"type":"extras","title":"Error Categories - Xbase","doc":"- **File Errors**: Missing files, permission issues, corruption\n- **Format Errors**: Invalid DBF structure, unsupported versions\n- **Data Errors**: Invalid field values, type mismatches\n- **Transaction Errors**: Rollback scenarios, concurrent access issues","ref":"readme.html#error-categories"},{"type":"extras","title":"🤝 Contributing - Xbase","doc":"We welcome contributions! Here's how you can help:","ref":"readme.html#contributing"},{"type":"extras","title":"Development Setup - Xbase","doc":"```bash\ngit clone https://github.com/your-org/xbase.git\ncd xbase\nmix deps.get\nmix test\n```","ref":"readme.html#development-setup"},{"type":"extras","title":"Contributing Guidelines - Xbase","doc":"- **Issues**: Report bugs or request features via GitHub Issues\n- **Pull Requests**: Fork, create a feature branch, and submit a PR\n- **Tests**: Ensure all tests pass and add tests for new features\n- **Documentation**: Update docs for any API changes","ref":"readme.html#contributing-guidelines"},{"type":"extras","title":"Running Tests - Xbase","doc":"```bash\nmix test                    # Run all tests\nmix test --cover           # Run with coverage\nmix dialyzer               # Type checking\nmix credo                  # Code quality\n```","ref":"readme.html#running-tests"},{"type":"extras","title":"📄 License - Xbase","doc":"This project is licensed under the MIT License - see the LICENSE file for details.","ref":"readme.html#license"},{"type":"extras","title":"🙏 Acknowledgments - Xbase","doc":"- Built with ❤️ for the Elixir community\n- Inspired by the need for modern dBase file handling\n- Thanks to all contributors and users\n\n---\n\n**Need help?** Check out our [documentation](https://hexdocs.pm/xbase/) or [open an issue](https://github.com/your-org/xbase/issues).","ref":"readme.html#acknowledgments"},{"type":"extras","title":"Getting Started with Xbase","doc":"# Getting Started with Xbase\n\nThis guide will help you get up and running with the Xbase library for reading and writing dBase database files.","ref":"getting_started.html"},{"type":"extras","title":"Installation - Getting Started with Xbase","doc":"Add Xbase to your dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:xbase, \"~> 0.1.0\"}\n  ]\nend\n```\n\nThen run:\n```bash\nmix deps.get\n```","ref":"getting_started.html#installation"},{"type":"extras","title":"Basic Concepts - Getting Started with Xbase","doc":"","ref":"getting_started.html#basic-concepts"},{"type":"extras","title":"DBF Files - Getting Started with Xbase","doc":"DBF (dBase) files are database files that store structured data in a table format. Each file contains:\n- **Header**: Metadata about the file structure\n- **Field Descriptors**: Schema definition (field names, types, lengths)\n- **Records**: The actual data rows","ref":"getting_started.html#dbf-files"},{"type":"extras","title":"File Types - Getting Started with Xbase","doc":"- **DBF**: Main database file containing structured records\n- **DBT**: Memo file for variable-length text fields (optional)\n- **CDX**: Index file for fast data access (optional)","ref":"getting_started.html#file-types"},{"type":"extras","title":"Field Types - Getting Started with Xbase","doc":"- **Character (C)**: Text fields with fixed width\n- **Numeric (N)**: Integer or decimal numbers\n- **Date (D)**: Date values in YYYYMMDD format\n- **Logical (L)**: Boolean true/false values\n- **Memo (M)**: Variable-length text stored in DBT file","ref":"getting_started.html#field-types"},{"type":"extras","title":"Your First DBF File - Getting Started with Xbase","doc":"","ref":"getting_started.html#your-first-dbf-file"},{"type":"extras","title":"Reading an Existing File - Getting Started with Xbase","doc":"```elixir\n# Open a DBF file\n{:ok, dbf} = Xbase.Parser.open_dbf(\"customers.dbf\")\n\n# Read the first record\n{:ok, record} = Xbase.Parser.read_record(dbf, 0)\nIO.inspect(record.data)\n# => %{\"NAME\" => \"John Doe\", \"AGE\" => 30, \"CITY\" => \"New York\"}\n\n# Read all records\n{:ok, records} = Xbase.Parser.read_records(dbf)\nIO.puts(\"Total records: #{length(records)}\")\n\n# Don't forget to close the file\nXbase.Parser.close_dbf(dbf)\n```","ref":"getting_started.html#reading-an-existing-file"},{"type":"extras","title":"Creating a New File - Getting Started with Xbase","doc":"```elixir\n# Define the field structure\nfields = [\n  %Xbase.Types.FieldDescriptor{name: \"NAME\", type: \"C\", length: 30},\n  %Xbase.Types.FieldDescriptor{name: \"AGE\", type: \"N\", length: 3, decimal_count: 0},\n  %Xbase.Types.FieldDescriptor{name: \"EMAIL\", type: \"C\", length: 50},\n  %Xbase.Types.FieldDescriptor{name: \"ACTIVE\", type: \"L\", length: 1}\n]\n\n# Create the DBF file\n{:ok, dbf} = Xbase.Parser.create_dbf(\"new_customers.dbf\", fields)\n\n# Add some records\n{:ok, dbf} = Xbase.Parser.append_record(dbf, %{\n  \"NAME\" => \"Alice Johnson\",\n  \"AGE\" => 25,\n  \"EMAIL\" => \"alice@example.com\",\n  \"ACTIVE\" => true\n})\n\n{:ok, dbf} = Xbase.Parser.append_record(dbf, %{\n  \"NAME\" => \"Bob Smith\",\n  \"AGE\" => 35,\n  \"EMAIL\" => \"bob@example.com\",\n  \"ACTIVE\" => false\n})\n\n# Close the file\nXbase.Parser.close_dbf(dbf)\n```","ref":"getting_started.html#creating-a-new-file"},{"type":"extras","title":"Working with Large Files - Getting Started with Xbase","doc":"For large files, use streaming to avoid loading everything into memory:\n\n```elixir\n{:ok, dbf} = Xbase.Parser.open_dbf(\"large_file.dbf\")\n\n# Process records in a memory-efficient way\nactive_customers = \n  dbf\n  |> Xbase.Parser.stream_records()\n  |> Stream.filter(fn record -> record.data[\"ACTIVE\"] == true end)\n  |> Stream.map(fn record -> record.data[\"NAME\"] end)\n  |> Enum.to_list()\n\nIO.puts(\"Active customers: #{length(active_customers)}\")\n\nXbase.Parser.close_dbf(dbf)\n```","ref":"getting_started.html#working-with-large-files"},{"type":"extras","title":"Updating Records - Getting Started with Xbase","doc":"```elixir\n{:ok, dbf} = Xbase.Parser.open_dbf(\"customers.dbf\", [:read, :write])\n\n# Update a specific record\n{:ok, dbf} = Xbase.Parser.update_record(dbf, 0, %{\n  \"AGE\" => 31,\n  \"EMAIL\" => \"newemail@example.com\"\n})\n\n# Mark a record as deleted\n{:ok, dbf} = Xbase.Parser.mark_deleted(dbf, 1)\n\n# Undelete a record\n{:ok, dbf} = Xbase.Parser.undelete_record(dbf, 1)\n\nXbase.Parser.close_dbf(dbf)\n```","ref":"getting_started.html#updating-records"},{"type":"extras","title":"Working with Memo Fields - Getting Started with Xbase","doc":"Memo fields allow storing variable-length text. Use `MemoHandler` for seamless integration:\n\n```elixir\n# Define fields including a memo field\nfields = [\n  %Xbase.Types.FieldDescriptor{name: \"TITLE\", type: \"C\", length: 50},\n  %Xbase.Types.FieldDescriptor{name: \"CONTENT\", type: \"M\", length: 10}\n]\n\n# Create file with memo support\n{:ok, handler} = Xbase.MemoHandler.create_dbf_with_memo(\"articles.dbf\", fields)\n\n# Add record with memo content\n{:ok, handler} = Xbase.MemoHandler.append_record_with_memo(handler, %{\n  \"TITLE\" => \"My First Article\",\n  \"CONTENT\" => \"This is a long article content that will be stored in the memo file...\"\n})\n\n# Read back with resolved memo content\n{:ok, record} = Xbase.MemoHandler.read_record_with_memo(handler, 0)\nIO.puts(\"Article: #{record[\"TITLE\"]}\")\nIO.puts(\"Content: #{record[\"CONTENT\"]}\")\n\nXbase.MemoHandler.close_memo_files(handler)\n```","ref":"getting_started.html#working-with-memo-fields"},{"type":"extras","title":"Error Handling - Getting Started with Xbase","doc":"Always handle errors appropriately:\n\n```elixir\ncase Xbase.Parser.open_dbf(\"data.dbf\") do\n  {:ok, dbf} ->\n    # Work with the file\n    {:ok, records} = Xbase.Parser.read_records(dbf)\n    Xbase.Parser.close_dbf(dbf)\n    {:ok, records}\n    \n  {:error, :enoent} ->\n    {:error, \"File not found\"}\n    \n  {:error, reason} ->\n    {:error, \"Failed to open file: #{inspect(reason)}\"}\nend\n```","ref":"getting_started.html#error-handling"},{"type":"extras","title":"Batch Operations for Performance - Getting Started with Xbase","doc":"When working with many records, use batch operations:\n\n```elixir\n{:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n\n# Batch append multiple records\nrecords = [\n  %{\"NAME\" => \"User 1\", \"AGE\" => 25},\n  %{\"NAME\" => \"User 2\", \"AGE\" => 30},\n  %{\"NAME\" => \"User 3\", \"AGE\" => 35}\n]\n\n{:ok, dbf} = Xbase.Parser.batch_append_records(dbf, records)\n\n# Batch update multiple records\nupdates = [\n  {0, %{\"AGE\" => 26}},\n  {1, %{\"AGE\" => 31}},\n  {2, %{\"AGE\" => 36}}\n]\n\n{:ok, dbf} = Xbase.Parser.batch_update_records(dbf, updates)\n\nXbase.Parser.close_dbf(dbf)\n```","ref":"getting_started.html#batch-operations-for-performance"},{"type":"extras","title":"Using Transactions - Getting Started with Xbase","doc":"Protect your data with transactions:\n\n```elixir\n{:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n\nresult = Xbase.Parser.with_transaction(dbf, fn dbf ->\n  # These operations will be rolled back if any fail\n  {:ok, dbf} = Xbase.Parser.append_record(dbf, record1)\n  {:ok, dbf} = Xbase.Parser.append_record(dbf, record2)\n  {:ok, dbf} = Xbase.Parser.update_record(dbf, 0, updates)\n  \n  # Return success\n  {:ok, :transaction_complete}\nend)\n\ncase result do\n  {:ok, :transaction_complete} ->\n    IO.puts(\"All operations completed successfully\")\n  {:error, reason} ->\n    IO.puts(\"Transaction failed and was rolled back: #{inspect(reason)}\")\nend\n\nXbase.Parser.close_dbf(dbf)\n```","ref":"getting_started.html#using-transactions"},{"type":"extras","title":"Next Steps - Getting Started with Xbase","doc":"Now that you've learned the basics, explore these advanced topics:\n\n1. **[Working with Indexes](indexes.md)** - Use CDX files for fast data access\n2. **[Streaming Large Files](streaming.md)** - Memory-efficient processing\n3. **[Advanced Memo Operations](memo_fields.md)** - Complex memo field handling\n4. **[Performance Optimization](performance.md)** - Tips for high-performance applications","ref":"getting_started.html#next-steps"},{"type":"extras","title":"Common Patterns - Getting Started with Xbase","doc":"","ref":"getting_started.html#common-patterns"},{"type":"extras","title":"Reading and Processing Data - Getting Started with Xbase","doc":"```elixir\ndefmodule DataProcessor do\n  def process_customers(file_path) do\n    with {:ok, dbf} <- Xbase.Parser.open_dbf(file_path) do\n      results = \n        dbf\n        |> Xbase.Parser.stream_records()\n        |> Stream.reject(fn record -> record.deleted end)\n        |> Stream.map(fn record -> process_customer(record.data) end)\n        |> Enum.to_list()\n      \n      Xbase.Parser.close_dbf(dbf)\n      {:ok, results}\n    end\n  end\n  \n  defp process_customer(customer_data) do\n    # Your processing logic here\n    customer_data\n  end\nend\n```","ref":"getting_started.html#reading-and-processing-data"},{"type":"extras","title":"Creating Reports - Getting Started with Xbase","doc":"```elixir\ndefmodule ReportGenerator do\n  def age_distribution(file_path) do\n    with {:ok, dbf} <- Xbase.Parser.open_dbf(file_path) do\n      distribution = \n        dbf\n        |> Xbase.Parser.stream_records()\n        |> Stream.reject(fn record -> record.deleted end)\n        |> Stream.map(fn record -> record.data[\"AGE\"] end)\n        |> Enum.frequencies()\n      \n      Xbase.Parser.close_dbf(dbf)\n      {:ok, distribution}\n    end\n  end\nend\n```","ref":"getting_started.html#creating-reports"},{"type":"extras","title":"Data Migration - Getting Started with Xbase","doc":"```elixir\ndefmodule DataMigration do\n  def migrate_to_new_format(source_path, target_path) do\n    # Define new field structure\n    new_fields = [\n      %Xbase.Types.FieldDescriptor{name: \"ID\", type: \"N\", length: 10},\n      %Xbase.Types.FieldDescriptor{name: \"FULL_NAME\", type: \"C\", length: 50},\n      %Xbase.Types.FieldDescriptor{name: \"AGE_GROUP\", type: \"C\", length: 10}\n    ]\n    \n    with {:ok, source_dbf} <- Xbase.Parser.open_dbf(source_path),\n         {:ok, target_dbf} <- Xbase.Parser.create_dbf(target_path, new_fields) do\n      \n      # Migrate data with transformation\n      final_dbf = \n        source_dbf\n        |> Xbase.Parser.stream_records()\n        |> Stream.reject(fn record -> record.deleted end)\n        |> Enum.reduce(target_dbf, fn record, acc_dbf ->\n          transformed = transform_record(record.data)\n          {:ok, new_dbf} = Xbase.Parser.append_record(acc_dbf, transformed)\n          new_dbf\n        end)\n      \n      Xbase.Parser.close_dbf(source_dbf)\n      Xbase.Parser.close_dbf(final_dbf)\n      :ok\n    end\n  end\n  \n  defp transform_record(old_data) do\n    %{\n      \"ID\" => old_data[\"CUSTOMER_ID\"],\n      \"FULL_NAME\" => \"#{old_data[\"FIRST_NAME\"]} #{old_data[\"LAST_NAME\"]}\",\n      \"AGE_GROUP\" => age_group(old_data[\"AGE\"])\n    }\n  end\n  \n  defp age_group(age) when age < 30, do: \"Young\"\n  defp age_group(age) when age < 60, do: \"Middle\"\n  defp age_group(_age), do: \"Senior\"\nend\n```","ref":"getting_started.html#data-migration"},{"type":"extras","title":"Working with Memo Fields","doc":"# Working with Memo Fields\n\nMemo fields allow storing variable-length text content in dBase files. Unlike fixed-width character fields, memo fields can contain large amounts of text stored in a separate DBT (memo) file.","ref":"memo_fields.html"},{"type":"extras","title":"Understanding Memo Fields - Working with Memo Fields","doc":"","ref":"memo_fields.html#understanding-memo-fields"},{"type":"extras","title":"What are Memo Fields? - Working with Memo Fields","doc":"Memo fields are designed for storing:\n- Long text content (articles, descriptions, comments)\n- Variable-length data that doesn't fit in fixed character fields\n- Rich text or formatted content\n- Any text content longer than 254 characters","ref":"memo_fields.html#what-are-memo-fields"},{"type":"extras","title":"File Structure - Working with Memo Fields","doc":"When you use memo fields, two files are involved:\n- **DBF file**: Contains the main records with memo field references\n- **DBT file**: Contains the actual memo content in blocks\n\nThe DBF file stores memo references (block numbers) while the DBT file stores the actual content.","ref":"memo_fields.html#file-structure"},{"type":"extras","title":"Basic Memo Operations - Working with Memo Fields","doc":"","ref":"memo_fields.html#basic-memo-operations"},{"type":"extras","title":"Creating Files with Memo Fields - Working with Memo Fields","doc":"```elixir\n# Define fields including memo fields\nfields = [\n  %Xbase.Types.FieldDescriptor{name: \"ID\", type: \"N\", length: 10},\n  %Xbase.Types.FieldDescriptor{name: \"TITLE\", type: \"C\", length: 50},\n  %Xbase.Types.FieldDescriptor{name: \"CONTENT\", type: \"M\", length: 10},    # Memo field\n  %Xbase.Types.FieldDescriptor{name: \"NOTES\", type: \"M\", length: 10}       # Another memo field\n]\n\n# Create coordinated DBF+DBT files\n{:ok, handler} = Xbase.MemoHandler.create_dbf_with_memo(\"articles.dbf\", fields)\n```","ref":"memo_fields.html#creating-files-with-memo-fields"},{"type":"extras","title":"Adding Records with Memo Content - Working with Memo Fields","doc":"```elixir\n# Add record with memo content\n{:ok, handler} = Xbase.MemoHandler.append_record_with_memo(handler, %{\n  \"ID\" => 1,\n  \"TITLE\" => \"Getting Started with Elixir\",\n  \"CONTENT\" => \"\"\"\n  Elixir is a dynamic, functional language designed for building maintainable and scalable applications.\n  \n  It leverages the Erlang Virtual Machine (BEAM), which gives it access to a battle-tested,\n  distributed, and fault-tolerant system. This makes Elixir particularly well-suited for\n  applications that require high availability and low latency.\n  \n  Key features of Elixir include:\n  - Pattern matching\n  - Actor model via lightweight processes\n  - Fault tolerance through supervision trees\n  - Functional programming paradigms\n  - Immutable data structures\n  \"\"\",\n  \"NOTES\" => \"This is an introductory article suitable for beginners.\"\n})\n```","ref":"memo_fields.html#adding-records-with-memo-content"},{"type":"extras","title":"Reading Records with Memo Content - Working with Memo Fields","doc":"```elixir\n# Read record with resolved memo content\n{:ok, record} = Xbase.MemoHandler.read_record_with_memo(handler, 0)\n\nIO.puts(\"Title: #{record[\"TITLE\"]}\")\nIO.puts(\"Content: #{record[\"CONTENT\"]}\")\nIO.puts(\"Notes: #{record[\"NOTES\"]}\")\n```","ref":"memo_fields.html#reading-records-with-memo-content"},{"type":"extras","title":"Updating Memo Content - Working with Memo Fields","doc":"```elixir\n# Update memo content\n{:ok, handler} = Xbase.MemoHandler.update_record_with_memo(handler, 0, %{\n  \"CONTENT\" => \"\"\"\n  [UPDATED] Elixir is a dynamic, functional language designed for building \n  maintainable and scalable applications...\n  \"\"\",\n  \"NOTES\" => \"Updated with additional examples and clarifications.\"\n})\n```","ref":"memo_fields.html#updating-memo-content"},{"type":"extras","title":"Advanced Memo Operations - Working with Memo Fields","doc":"","ref":"memo_fields.html#advanced-memo-operations"},{"type":"extras","title":"Working with Large Memo Content - Working with Memo Fields","doc":"```elixir\n# Reading large content from file\nlarge_content = File.read!(\"large_document.txt\")\n\n{:ok, handler} = Xbase.MemoHandler.append_record_with_memo(handler, %{\n  \"ID\" => 2,\n  \"TITLE\" => \"Large Document\",\n  \"CONTENT\" => large_content\n})\n```","ref":"memo_fields.html#working-with-large-memo-content"},{"type":"extras","title":"Batch Operations with Memos - Working with Memo Fields","doc":"```elixir\n# Prepare multiple records with memo content\narticles = [\n  %{\n    \"ID\" => 1,\n    \"TITLE\" => \"Article 1\",\n    \"CONTENT\" => \"Content for article 1...\",\n    \"NOTES\" => \"Notes for article 1\"\n  },\n  %{\n    \"ID\" => 2,\n    \"TITLE\" => \"Article 2\", \n    \"CONTENT\" => \"Content for article 2...\",\n    \"NOTES\" => \"Notes for article 2\"\n  }\n]\n\n# Add them one by one (batch support would be a future enhancement)\nfinal_handler = Enum.reduce(articles, handler, fn article, acc_handler ->\n  {:ok, updated_handler} = Xbase.MemoHandler.append_record_with_memo(acc_handler, article)\n  updated_handler\nend)\n```","ref":"memo_fields.html#batch-operations-with-memos"},{"type":"extras","title":"Mixed Memo References and Content - Working with Memo Fields","doc":"You can work with both memo content (strings) and memo references (tuples) in the same operation:\n\n```elixir\n# Use existing memo reference for one field, new content for another\n{:ok, handler} = Xbase.MemoHandler.append_record_with_memo(handler, %{\n  \"ID\" => 3,\n  \"TITLE\" => \"Mixed Content\",\n  \"CONTENT\" => \"This is new content that will be stored in the DBT file\",\n  \"NOTES\" => {:memo_ref, 1}  # Reuse memo content from block 1\n})\n```","ref":"memo_fields.html#mixed-memo-references-and-content"},{"type":"extras","title":"Transaction Safety - Working with Memo Fields","doc":"","ref":"memo_fields.html#transaction-safety"},{"type":"extras","title":"Memo Transactions - Working with Memo Fields","doc":"Memo operations can be wrapped in transactions for ACID compliance:\n\n```elixir\n{:ok, {result, final_handler}} = Xbase.MemoHandler.memo_transaction(handler, fn h ->\n  # These operations are atomic across both DBF and DBT files\n  {:ok, h1} = Xbase.MemoHandler.append_record_with_memo(h, article1)\n  {:ok, h2} = Xbase.MemoHandler.append_record_with_memo(h1, article2)\n  {:ok, h3} = Xbase.MemoHandler.update_record_with_memo(h2, 0, updates)\n  \n  {:ok, :batch_complete, h3}\nend)\n\ncase result do\n  :batch_complete ->\n    IO.puts(\"All memo operations completed successfully\")\n  {:error, reason} ->\n    IO.puts(\"Transaction failed and was rolled back: #{inspect(reason)}\")\nend\n```","ref":"memo_fields.html#memo-transactions"},{"type":"extras","title":"Low-Level Memo Operations - Working with Memo Fields","doc":"For advanced use cases, you can work directly with DBT files:","ref":"memo_fields.html#low-level-memo-operations"},{"type":"extras","title":"Direct DBT File Operations - Working with Memo Fields","doc":"```elixir\n# Open DBT file directly\n{:ok, dbt} = Xbase.DbtParser.open_dbt(\"articles.dbt\")\n\n# Read memo content by block number\n{:ok, content} = Xbase.DbtParser.read_memo(dbt, 1)\nIO.puts(\"Memo content: #{content}\")\n\n# Close DBT file\nXbase.DbtParser.close_dbt(dbt)\n```","ref":"memo_fields.html#direct-dbt-file-operations"},{"type":"extras","title":"Writing to DBT Files - Working with Memo Fields","doc":"```elixir\n# Open DBT file for writing\n{:ok, dbt} = Xbase.DbtWriter.open_dbt_for_writing(\"articles.dbt\")\n\n# Write new memo content\n{:ok, {block_number, updated_dbt}} = Xbase.DbtWriter.write_memo(dbt, \"New memo content\")\nIO.puts(\"Content stored in block: #{block_number}\")\n\n# Update existing memo\n{:ok, updated_dbt} = Xbase.DbtWriter.update_memo(updated_dbt, block_number, \"Updated content\")\n\n# Close file\nXbase.DbtWriter.close_dbt(updated_dbt)\n```","ref":"memo_fields.html#writing-to-dbt-files"},{"type":"extras","title":"Performance Considerations - Working with Memo Fields","doc":"","ref":"memo_fields.html#performance-considerations"},{"type":"extras","title":"Memo Caching - Working with Memo Fields","doc":"The library includes built-in caching for frequently accessed memo content:\n\n```elixir\n# First read - loads from file\n{:ok, record1} = Xbase.MemoHandler.read_record_with_memo(handler, 0)\n\n# Subsequent reads - served from cache if recently accessed\n{:ok, record2} = Xbase.MemoHandler.read_record_with_memo(handler, 0)\n```","ref":"memo_fields.html#memo-caching"},{"type":"extras","title":"Memory Management - Working with Memo Fields","doc":"For large memo files, consider:\n\n1. **Streaming access**: Process records one at a time\n2. **Selective reading**: Only resolve memo content when needed\n3. **Cache management**: Built-in LRU cache manages memory automatically\n\n```elixir\n# Memory-efficient processing of large memo files\n{:ok, dbf} = Xbase.Parser.open_dbf(\"large_memo_file.dbf\")\n\n# Process records without resolving all memo content\nsummary = \n  dbf\n  |> Xbase.Parser.stream_records()\n  |> Stream.map(fn record -> \n    # Only extract non-memo fields for summary\n    %{\n      id: record.data[\"ID\"],\n      title: record.data[\"TITLE\"],\n      has_content: match?({:memo_ref, n} when n > 0, record.data[\"CONTENT\"])\n    }\n  end)\n  |> Enum.to_list()\n\nXbase.Parser.close_dbf(dbf)\n```","ref":"memo_fields.html#memory-management"},{"type":"extras","title":"File Management - Working with Memo Fields","doc":"","ref":"memo_fields.html#file-management"},{"type":"extras","title":"DBT File Compaction - Working with Memo Fields","doc":"Over time, DBT files can become fragmented. Use compaction to optimize:\n\n```elixir\n# Open DBT file for analysis\n{:ok, dbt} = Xbase.DbtWriter.open_dbt_for_writing(\"articles.dbt\")\n\n# Analyze fragmentation\n{:ok, stats} = Xbase.DbtWriter.analyze_fragmentation(dbt)\nIO.inspect(stats)\n# => %{total_blocks: 100, used_blocks: 60, free_blocks: 40, fragmentation_ratio: 0.4}\n\n# Compact if fragmentation is high\nif stats.fragmentation_ratio > 0.3 do\n  {:ok, compacted_dbt} = Xbase.DbtWriter.compact_dbt(dbt, \"articles_compacted.dbt\")\n  # Replace original with compacted version\n  File.rename(\"articles_compacted.dbt\", \"articles.dbt\")\nend\n```","ref":"memo_fields.html#dbt-file-compaction"},{"type":"extras","title":"File Coordination - Working with Memo Fields","doc":"When working with both DBF and DBT files manually, ensure proper coordination:\n\n```elixir\n# Always open both files together\n{:ok, dbf} = Xbase.Parser.open_dbf(\"data.dbf\", [:read, :write])\n{:ok, dbt} = Xbase.DbtWriter.open_dbt_for_writing(\"data.dbt\")\n\n# Coordinate operations\n{:ok, {memo_block, updated_dbt}} = Xbase.DbtWriter.write_memo(dbt, \"New content\")\n{:ok, updated_dbf} = Xbase.Parser.append_record(dbf, %{\n  \"TITLE\" => \"New Record\",\n  \"CONTENT\" => {:memo_ref, memo_block}\n})\n\n# Close both files\nXbase.Parser.close_dbf(updated_dbf)\nXbase.DbtWriter.close_dbt(updated_dbt)\n```","ref":"memo_fields.html#file-coordination"},{"type":"extras","title":"Error Handling - Working with Memo Fields","doc":"","ref":"memo_fields.html#error-handling"},{"type":"extras","title":"Common Memo Errors - Working with Memo Fields","doc":"```elixir\ncase Xbase.MemoHandler.append_record_with_memo(handler, record_data) do\n  {:ok, updated_handler} ->\n    # Success\n    updated_handler\n    \n  {:error, {:memo_content_without_dbt, field_names}} ->\n    IO.puts(\"Memo content provided but no DBT file available for fields: #{inspect(field_names)}\")\n    \n  {:error, {:invalid_memo_value, field_name, value}} ->\n    IO.puts(\"Invalid memo value for field #{field_name}: #{inspect(value)}\")\n    \n  {:error, {:memo_write_failed, field_name, reason}} ->\n    IO.puts(\"Failed to write memo content for #{field_name}: #{inspect(reason)}\")\n    \n  {:error, reason} ->\n    IO.puts(\"Memo operation failed: #{inspect(reason)}\")\nend\n```","ref":"memo_fields.html#common-memo-errors"},{"type":"extras","title":"Recovery Strategies - Working with Memo Fields","doc":"```elixir\ndefmodule MemoRecovery do\n  def safe_memo_operation(handler, record_data) do\n    case Xbase.MemoHandler.memo_transaction(handler, fn h ->\n      Xbase.MemoHandler.append_record_with_memo(h, record_data)\n    end) do\n      {:ok, {updated_handler, _result}} ->\n        {:ok, updated_handler}\n        \n      {:error, reason} ->\n        # Transaction automatically rolled back\n        IO.puts(\"Memo operation failed, rolling back: #{inspect(reason)}\")\n        {:error, reason}\n    end\n  end\n  \n  def repair_memo_references(dbf_path, dbt_path) do\n    # Custom recovery logic for corrupted memo references\n    # This is a simplified example\n    with {:ok, dbf} <- Xbase.Parser.open_dbf(dbf_path),\n         {:ok, dbt} <- Xbase.DbtParser.open_dbt(dbt_path) do\n      \n      # Validate all memo references\n      records = Xbase.Parser.read_all_records(dbf)\n      \n      invalid_refs = \n        records\n        |> Enum.with_index()\n        |> Enum.flat_map(fn {record, index} ->\n          validate_memo_refs(record, index, dbt)\n        end)\n      \n      Xbase.Parser.close_dbf(dbf)\n      Xbase.DbtParser.close_dbt(dbt)\n      \n      if Enum.empty?(invalid_refs) do\n        {:ok, \"All memo references are valid\"}\n      else\n        {:error, \"Invalid memo references found: #{inspect(invalid_refs)}\"}\n      end\n    end\n  end\n  \n  defp validate_memo_refs(record, index, dbt) do\n    record.data\n    |> Enum.flat_map(fn {field_name, value} ->\n      case value do\n        {:memo_ref, block_num} when block_num > 0 ->\n          case Xbase.DbtParser.read_memo(dbt, block_num) do\n            {:ok, _content} -> []\n            {:error, _reason} -> [{index, field_name, block_num}]\n          end\n        _ -> []\n      end\n    end)\n  end\nend\n```","ref":"memo_fields.html#recovery-strategies"},{"type":"extras","title":"Best Practices - Working with Memo Fields","doc":"","ref":"memo_fields.html#best-practices"},{"type":"extras","title":"1. Use MemoHandler for Simplicity - Working with Memo Fields","doc":"```elixir\n# Preferred approach\n{:ok, handler} = Xbase.MemoHandler.open_dbf_with_memo(\"data.dbf\", [:read, :write])\n# Work with memo content as strings\n```","ref":"memo_fields.html#1-use-memohandler-for-simplicity"},{"type":"extras","title":"2. Handle Large Content Appropriately - Working with Memo Fields","doc":"```elixir\n# For very large content, consider chunking or streaming\ndef process_large_memo_file(file_path) do\n  {:ok, handler} = Xbase.MemoHandler.open_dbf_with_memo(file_path)\n  \n  # Process one record at a time to manage memory\n  record_count = handler.dbf.header.record_count\n  \n  Enum.each(0..(record_count - 1), fn index ->\n    {:ok, record} = Xbase.MemoHandler.read_record_with_memo(handler, index)\n    process_record(record)\n  end)\n  \n  Xbase.MemoHandler.close_memo_files(handler)\nend\n```","ref":"memo_fields.html#2-handle-large-content-appropriately"},{"type":"extras","title":"3. Use Transactions for Data Integrity - Working with Memo Fields","doc":"```elixir\n# Always use transactions for critical operations\nXbase.MemoHandler.memo_transaction(handler, fn h ->\n  # Multiple related operations\n  {:ok, h1} = Xbase.MemoHandler.append_record_with_memo(h, record1)\n  {:ok, h2} = Xbase.MemoHandler.update_record_with_memo(h1, 0, updates)\n  {:ok, :success, h2}\nend)\n```","ref":"memo_fields.html#3-use-transactions-for-data-integrity"},{"type":"extras","title":"4. Monitor DBT File Health - Working with Memo Fields","doc":"```elixir\ndef check_memo_file_health(dbt_path) do\n  {:ok, dbt} = Xbase.DbtWriter.open_dbt_for_writing(dbt_path)\n  {:ok, stats} = Xbase.DbtWriter.analyze_fragmentation(dbt)\n  \n  cond do\n    stats.fragmentation_ratio > 0.5 ->\n      {:warning, \"High fragmentation, consider compacting\"}\n    stats.fragmentation_ratio > 0.3 ->\n      {:info, \"Moderate fragmentation\"}\n    true ->\n      {:ok, \"File is well-optimized\"}\n  end\nend\n```","ref":"memo_fields.html#4-monitor-dbt-file-health"},{"type":"extras","title":"Working with Indexes","doc":"# Working with Indexes\n\nCDX (Compound Index) files provide fast B-tree based lookups for DBF files. Indexes dramatically improve search performance on large datasets by maintaining sorted key structures.","ref":"indexes.html"},{"type":"extras","title":"Understanding CDX Indexes - Working with Indexes","doc":"","ref":"indexes.html#understanding-cdx-indexes"},{"type":"extras","title":"What are CDX Indexes? - Working with Indexes","doc":"CDX files are compound index files that store:\n- **B-tree structures** for fast key lookups\n- **Multiple indexes** in a single file\n- **Key expressions** for complex indexing\n- **Sort order information** for proper collation","ref":"indexes.html#what-are-cdx-indexes"},{"type":"extras","title":"Benefits of Using Indexes - Working with Indexes","doc":"- **Fast Searches**: O(log n) lookup time vs O(n) linear search\n- **Range Queries**: Efficient range-based searches\n- **Sorted Access**: Iterate through records in key order\n- **Multiple Keys**: Support for multiple indexes per file","ref":"indexes.html#benefits-of-using-indexes"},{"type":"extras","title":"Basic Index Operations - Working with Indexes","doc":"","ref":"indexes.html#basic-index-operations"},{"type":"extras","title":"Opening Index Files - Working with Indexes","doc":"```elixir\n# Open DBF and its associated CDX file\n{:ok, dbf} = Xbase.Parser.open_dbf(\"customers.dbf\")\n{:ok, cdx} = Xbase.CdxParser.open_cdx(\"customers.cdx\")\n\n# Index files typically have the same name as DBF with .cdx extension\n{:ok, cdx} = Xbase.CdxParser.open_cdx(\"customers.cdx\")\n```","ref":"indexes.html#opening-index-files"},{"type":"extras","title":"Creating Index Files - Working with Indexes","doc":"```elixir\n# Create index on a field\n{:ok, cdx} = Xbase.CdxParser.create_index(\"customers.cdx\", %{\n  key_expression: \"LAST_NAME\",\n  key_length: 30,\n  index_name: \"LASTNAME_IDX\"\n})\n\n# Create compound index (multiple fields)\n{:ok, cdx} = Xbase.CdxParser.create_index(\"customers.cdx\", %{\n  key_expression: \"LAST_NAME + FIRST_NAME\",\n  key_length: 60,\n  index_name: \"FULLNAME_IDX\"\n})\n\n# Create expression-based index\n{:ok, cdx} = Xbase.CdxParser.create_index(\"orders.cdx\", %{\n  key_expression: \"DTOS(ORDER_DATE) + STR(AMOUNT, 10, 2)\",\n  key_length: 18,\n  index_name: \"DATE_AMOUNT_IDX\"\n})\n```","ref":"indexes.html#creating-index-files"},{"type":"extras","title":"Search Operations - Working with Indexes","doc":"","ref":"indexes.html#search-operations"},{"type":"extras","title":"Exact Key Searches - Working with Indexes","doc":"```elixir\n# Search for exact key match\ncase Xbase.CdxParser.search_key(cdx, \"SMITH\") do\n  {:ok, %{record_number: record_num, found: true}} ->\n    # Key found, get the record\n    {:ok, record} = Xbase.Parser.read_record(dbf, record_num)\n    IO.inspect(record.data)\n    \n  {:ok, %{found: false}} ->\n    IO.puts(\"Key not found\")\n    \n  {:error, reason} ->\n    IO.puts(\"Search error: #{inspect(reason)}\")\nend\n```","ref":"indexes.html#exact-key-searches"},{"type":"extras","title":"Range Searches - Working with Indexes","doc":"```elixir\n# Find all records with keys between \"A\" and \"M\"\n{:ok, results} = Xbase.CdxParser.search_range(cdx, \"A\", \"M\")\n\n# Process matching records\nEnum.each(results, fn %{record_number: record_num, key_value: key} ->\n  {:ok, record} = Xbase.Parser.read_record(dbf, record_num)\n  IO.puts(\"#{key}: #{record.data[\"FIRST_NAME\"]} #{record.data[\"LAST_NAME\"]}\")\nend)\n```","ref":"indexes.html#range-searches"},{"type":"extras","title":"Partial Key Searches - Working with Indexes","doc":"```elixir\n# Find all keys starting with \"SMI\"\n{:ok, matches} = Xbase.CdxParser.search_partial(cdx, \"SMI\")\n\n# Get first 10 matching records\nmatches\n|> Enum.take(10)\n|> Enum.each(fn %{record_number: record_num} ->\n  {:ok, record} = Xbase.Parser.read_record(dbf, record_num)\n  IO.inspect(record.data)\nend)\n```","ref":"indexes.html#partial-key-searches"},{"type":"extras","title":"Advanced Index Usage - Working with Indexes","doc":"","ref":"indexes.html#advanced-index-usage"},{"type":"extras","title":"Multiple Indexes - Working with Indexes","doc":"```elixir\n# Work with multiple indexes on the same file\n{:ok, name_idx} = Xbase.CdxParser.open_index(cdx, \"LASTNAME_IDX\")\n{:ok, date_idx} = Xbase.CdxParser.open_index(cdx, \"BIRTHDATE_IDX\")\n{:ok, amount_idx} = Xbase.CdxParser.open_index(cdx, \"AMOUNT_IDX\")\n\n# Search using different indexes\n{:ok, by_name} = Xbase.CdxParser.search_key(name_idx, \"JOHNSON\")\n{:ok, by_date} = Xbase.CdxParser.search_range(date_idx, \"19900101\", \"19991231\")\n{:ok, by_amount} = Xbase.CdxParser.search_range(amount_idx, \"1000.00\", \"9999.99\")\n```","ref":"indexes.html#multiple-indexes"},{"type":"extras","title":"Ordered Iteration - Working with Indexes","doc":"```elixir\n# Iterate through records in index order\n{:ok, iterator} = Xbase.CdxParser.create_iterator(cdx)\n\n# Process records in sorted order\nXbase.CdxParser.iterate_keys(iterator, fn key_info ->\n  {:ok, record} = Xbase.Parser.read_record(dbf, key_info.record_number)\n  process_record_in_order(record)\n  :continue  # or :halt to stop\nend)\n```","ref":"indexes.html#ordered-iteration"},{"type":"extras","title":"Index Maintenance - Working with Indexes","doc":"```elixir\n# Rebuild index for consistency\n{:ok, cdx} = Xbase.CdxParser.rebuild_index(cdx, dbf)\n\n# Compact index to remove fragmentation\n{:ok, compacted_cdx} = Xbase.CdxParser.compact_index(cdx, \"customers_new.cdx\")\n\n# Verify index integrity\ncase Xbase.CdxParser.verify_index(cdx, dbf) do\n  {:ok, :valid} ->\n    IO.puts(\"Index is consistent with DBF file\")\n  {:error, inconsistencies} ->\n    IO.puts(\"Index inconsistencies found: #{inspect(inconsistencies)}\")\nend\n```","ref":"indexes.html#index-maintenance"},{"type":"extras","title":"Performance Optimization - Working with Indexes","doc":"","ref":"indexes.html#performance-optimization"},{"type":"extras","title":"Index Selection Strategy - Working with Indexes","doc":"```elixir\n# Choose indexes based on query patterns\ndefmodule IndexStrategy do\n  def choose_index(query_type, available_indexes) do\n    case query_type do\n      {:exact_match, field} ->\n        find_best_index_for_field(available_indexes, field)\n        \n      {:range_query, field} ->\n        find_sorted_index_for_field(available_indexes, field)\n        \n      {:compound_search, fields} ->\n        find_compound_index(available_indexes, fields)\n    end\n  end\n  \n  defp find_best_index_for_field(indexes, field) do\n    # Find index with field as primary key\n    Enum.find(indexes, fn idx ->\n      idx.key_expression == field or \n      String.starts_with?(idx.key_expression, field <> \" + \")\n    end)\n  end\nend\n```","ref":"indexes.html#index-selection-strategy"},{"type":"extras","title":"Caching Strategies - Working with Indexes","doc":"```elixir\n# Use ETS for index result caching\ndefmodule IndexCache do\n  def setup_cache do\n    :ets.new(:index_cache, [:set, :public, :named_table])\n  end\n  \n  def cached_search(cdx, key) do\n    case :ets.lookup(:index_cache, key) do\n      [{^key, result}] ->\n        result\n      [] ->\n        result = Xbase.CdxParser.search_key(cdx, key)\n        :ets.insert(:index_cache, {key, result})\n        result\n    end\n  end\nend\n```","ref":"indexes.html#caching-strategies"},{"type":"extras","title":"Index Types and Expressions - Working with Indexes","doc":"","ref":"indexes.html#index-types-and-expressions"},{"type":"extras","title":"Simple Field Indexes - Working with Indexes","doc":"```elixir\n# Single field indexes\nindexes = [\n  %{key_expression: \"CUSTOMER_ID\", key_length: 10},    # Numeric field\n  %{key_expression: \"LAST_NAME\", key_length: 30},      # Character field\n  %{key_expression: \"ORDER_DATE\", key_length: 8},      # Date field\n  %{key_expression: \"IS_ACTIVE\", key_length: 1}        # Logical field\n]\n```","ref":"indexes.html#simple-field-indexes"},{"type":"extras","title":"Compound Field Indexes - Working with Indexes","doc":"```elixir\n# Multiple field indexes for complex queries\ncompound_indexes = [\n  %{\n    key_expression: \"STATE + CITY + LAST_NAME\",\n    key_length: 65,\n    name: \"GEOGRAPHIC_NAME\"\n  },\n  %{\n    key_expression: \"DTOS(ORDER_DATE) + CUSTOMER_ID\",\n    key_length: 18,\n    name: \"DATE_CUSTOMER\"\n  }\n]\n```","ref":"indexes.html#compound-field-indexes"},{"type":"extras","title":"Expression-Based Indexes - Working with Indexes","doc":"```elixir\n# Complex expression indexes\nexpression_indexes = [\n  %{\n    # Uppercase index for case-insensitive searches\n    key_expression: \"UPPER(LAST_NAME)\",\n    key_length: 30,\n    name: \"UPPER_LASTNAME\"\n  },\n  %{\n    # Combined date and amount for financial queries\n    key_expression: \"DTOS(ORDER_DATE) + STR(AMOUNT, 12, 2)\",\n    key_length: 20,\n    name: \"DATE_AMOUNT\"\n  },\n  %{\n    # Full name concatenation\n    key_expression: \"TRIM(FIRST_NAME) + ' ' + TRIM(LAST_NAME)\",\n    key_length: 61,\n    name: \"FULL_NAME\"\n  }\n]\n```","ref":"indexes.html#expression-based-indexes"},{"type":"extras","title":"Common Index Patterns - Working with Indexes","doc":"","ref":"indexes.html#common-index-patterns"},{"type":"extras","title":"Customer Database - Working with Indexes","doc":"```elixir\n# Typical indexes for a customer database\ndefmodule CustomerIndexes do\n  def create_standard_indexes(dbf_path) do\n    cdx_path = String.replace(dbf_path, \".dbf\", \".cdx\")\n    \n    indexes = [\n      # Primary key\n      %{key_expression: \"CUSTOMER_ID\", key_length: 10, name: \"PK_CUSTOMER\"},\n      \n      # Name searches\n      %{key_expression: \"LAST_NAME\", key_length: 30, name: \"IDX_LASTNAME\"},\n      %{key_expression: \"LAST_NAME + FIRST_NAME\", key_length: 60, name: \"IDX_FULLNAME\"},\n      \n      # Geographic searches\n      %{key_expression: \"STATE + CITY\", key_length: 35, name: \"IDX_LOCATION\"},\n      \n      # Contact searches\n      %{key_expression: \"EMAIL\", key_length: 50, name: \"IDX_EMAIL\"},\n      %{key_expression: \"PHONE\", key_length: 15, name: \"IDX_PHONE\"},\n      \n      # Business logic\n      %{key_expression: \"UPPER(COMPANY_NAME)\", key_length: 50, name: \"IDX_COMPANY\"}\n    ]\n    \n    {:ok, cdx} = Xbase.CdxParser.create_multiple_indexes(cdx_path, indexes)\n    cdx\n  end\nend\n```","ref":"indexes.html#customer-database"},{"type":"extras","title":"Sales Database - Working with Indexes","doc":"```elixir\n# Indexes optimized for sales queries\ndefmodule SalesIndexes do\n  def create_sales_indexes(dbf_path) do\n    cdx_path = String.replace(dbf_path, \".dbf\", \".cdx\")\n    \n    indexes = [\n      # Time-based queries\n      %{key_expression: \"DTOS(SALE_DATE)\", key_length: 8, name: \"IDX_DATE\"},\n      %{key_expression: \"DTOS(SALE_DATE) + CUSTOMER_ID\", key_length: 18, name: \"IDX_DATE_CUSTOMER\"},\n      \n      # Amount-based queries\n      %{key_expression: \"STR(AMOUNT, 12, 2)\", key_length: 12, name: \"IDX_AMOUNT\"},\n      %{key_expression: \"PRODUCT_CODE + DTOS(SALE_DATE)\", key_length: 18, name: \"IDX_PRODUCT_DATE\"},\n      \n      # Status tracking\n      %{key_expression: \"STATUS + DTOS(SALE_DATE)\", key_length: 11, name: \"IDX_STATUS_DATE\"},\n      \n      # Salesperson performance\n      %{key_expression: \"SALESPERSON_ID + DTOS(SALE_DATE)\", key_length: 18, name: \"IDX_SALES_PERSON\"}\n    ]\n    \n    {:ok, cdx} = Xbase.CdxParser.create_multiple_indexes(cdx_path, indexes)\n    cdx\n  end\nend\n```","ref":"indexes.html#sales-database"},{"type":"extras","title":"Error Handling - Working with Indexes","doc":"","ref":"indexes.html#error-handling"},{"type":"extras","title":"Index-Specific Errors - Working with Indexes","doc":"```elixir\ndefmodule IndexErrorHandler do\n  def safe_index_operation(operation_fn) do\n    try do\n      operation_fn.()\n    rescue\n      error ->\n        handle_index_error(error)\n    end\n  end\n  \n  defp handle_index_error(error) do\n    case error do\n      %{reason: :index_corrupted} ->\n        {:error, \"Index file is corrupted and needs rebuilding\"}\n        \n      %{reason: :key_too_long} ->\n        {:error, \"Search key exceeds maximum index key length\"}\n        \n      %{reason: :index_not_found} ->\n        {:error, \"Specified index does not exist in CDX file\"}\n        \n      %{reason: :unsupported_expression} ->\n        {:error, \"Index expression contains unsupported functions\"}\n        \n      _ ->\n        {:error, \"Unexpected index error: #{inspect(error)}\"}\n    end\n  end\nend\n```","ref":"indexes.html#index-specific-errors"},{"type":"extras","title":"Recovery Procedures - Working with Indexes","doc":"```elixir\ndefmodule IndexRecovery do\n  def recover_corrupted_index(cdx_path, dbf_path) do\n    with {:ok, dbf} <- Xbase.Parser.open_dbf(dbf_path),\n         {:ok, backup_path} <- create_backup(cdx_path),\n         {:ok, cdx} <- rebuild_from_dbf(cdx_path, dbf) do\n      \n      case Xbase.CdxParser.verify_index(cdx, dbf) do\n        {:ok, :valid} ->\n          File.rm(backup_path)\n          {:ok, \"Index successfully recovered\"}\n          \n        {:error, _} ->\n          File.rename(backup_path, cdx_path)\n          {:error, \"Recovery failed, original index restored\"}\n      end\n    end\n  end\n  \n  defp create_backup(cdx_path) do\n    backup_path = cdx_path <> \".backup\"\n    case File.copy(cdx_path, backup_path) do\n      {:ok, _} -> {:ok, backup_path}\n      error -> error\n    end\n  end\n  \n  defp rebuild_from_dbf(cdx_path, dbf) do\n    # Extract index definitions from existing CDX or use defaults\n    index_definitions = extract_index_definitions(cdx_path)\n    Xbase.CdxParser.create_multiple_indexes(cdx_path, index_definitions)\n  end\nend\n```","ref":"indexes.html#recovery-procedures"},{"type":"extras","title":"Best Practices - Working with Indexes","doc":"","ref":"indexes.html#best-practices"},{"type":"extras","title":"1. Index Design Guidelines - Working with Indexes","doc":"```elixir\n# Good index design principles\ndefmodule IndexDesignGuidelines do\n  def design_indexes(table_analysis) do\n    [\n      # Index frequently searched fields\n      create_search_indexes(table_analysis.search_patterns),\n      \n      # Index foreign key relationships\n      create_relationship_indexes(table_analysis.relationships),\n      \n      # Index sort operations\n      create_sort_indexes(table_analysis.sort_patterns),\n      \n      # Compound indexes for multi-field queries\n      create_compound_indexes(table_analysis.compound_queries)\n    ]\n    |> List.flatten()\n  end\n  \n  defp create_search_indexes(search_patterns) do\n    search_patterns\n    |> Enum.filter(fn pattern -> pattern.frequency > 0.1 end)  # 10% threshold\n    |> Enum.map(fn pattern ->\n      %{\n        key_expression: pattern.field,\n        key_length: calculate_key_length(pattern.field),\n        name: \"IDX_#{String.upcase(pattern.field)}\"\n      }\n    end)\n  end\nend\n```","ref":"indexes.html#1-index-design-guidelines"},{"type":"extras","title":"2. Maintenance Schedule - Working with Indexes","doc":"```elixir\ndefmodule IndexMaintenance do\n  def schedule_maintenance(cdx_files) do\n    Enum.each(cdx_files, fn cdx_path ->\n      case analyze_index_health(cdx_path) do\n        {:needs_rebuild, reason} ->\n          schedule_rebuild(cdx_path, reason)\n          \n        {:needs_compact, fragmentation} ->\n          schedule_compaction(cdx_path, fragmentation)\n          \n        {:healthy, stats} ->\n          log_health_status(cdx_path, stats)\n      end\n    end)\n  end\n  \n  defp analyze_index_health(cdx_path) do\n    with {:ok, cdx} <- Xbase.CdxParser.open_cdx(cdx_path),\n         {:ok, stats} <- Xbase.CdxParser.get_index_statistics(cdx) do\n      \n      cond do\n        stats.corruption_detected -> {:needs_rebuild, :corruption}\n        stats.fragmentation_ratio > 0.4 -> {:needs_compact, stats.fragmentation_ratio}\n        true -> {:healthy, stats}\n      end\n    end\n  end\nend\n```","ref":"indexes.html#2-maintenance-schedule"},{"type":"extras","title":"3. Performance Monitoring - Working with Indexes","doc":"```elixir\ndefmodule IndexPerformanceMonitor do\n  def monitor_index_performance(cdx, operations) do\n    Enum.map(operations, fn operation ->\n      {time, result} = :timer.tc(fn -> execute_operation(cdx, operation) end)\n      \n      %{\n        operation: operation,\n        execution_time_ms: time / 1000,\n        result: result,\n        performance_rating: rate_performance(time, operation)\n      }\n    end)\n  end\n  \n  defp rate_performance(time_microseconds, operation) do\n    time_ms = time_microseconds / 1000\n    \n    case operation.type do\n      :exact_search when time_ms < 1 -> :excellent\n      :exact_search when time_ms < 10 -> :good\n      :range_query when time_ms < 50 -> :excellent\n      :range_query when time_ms < 200 -> :good\n      _ -> :needs_optimization\n    end\n  end\nend\n```","ref":"indexes.html#3-performance-monitoring"},{"type":"extras","title":"Integration with DBF Operations - Working with Indexes","doc":"","ref":"indexes.html#integration-with-dbf-operations"},{"type":"extras","title":"Coordinated File Operations - Working with Indexes","doc":"```elixir\ndefmodule CoordinatedOperations do\n  def insert_with_index_update(dbf, cdx, record_data) do\n    Xbase.Parser.with_transaction(dbf, fn dbf ->\n      # Add record to DBF\n      {:ok, updated_dbf} = Xbase.Parser.append_record(dbf, record_data)\n      \n      # Update all indexes\n      record_index = updated_dbf.header.record_count - 1\n      {:ok, updated_cdx} = update_all_indexes(cdx, record_data, record_index)\n      \n      {:ok, {updated_dbf, updated_cdx}}\n    end)\n  end\n  \n  def update_with_index_maintenance(dbf, cdx, record_index, new_data) do\n    # Get old record for index removal\n    {:ok, old_record} = Xbase.Parser.read_record(dbf, record_index)\n    \n    Xbase.Parser.with_transaction(dbf, fn dbf ->\n      # Update DBF record\n      {:ok, updated_dbf} = Xbase.Parser.update_record(dbf, record_index, new_data)\n      \n      # Remove old index entries\n      {:ok, cdx_after_removal} = remove_from_indexes(cdx, old_record.data, record_index)\n      \n      # Add new index entries\n      {:ok, updated_cdx} = add_to_indexes(cdx_after_removal, new_data, record_index)\n      \n      {:ok, {updated_dbf, updated_cdx}}\n    end)\n  end\n  \n  defp update_all_indexes(cdx, record_data, record_index) do\n    # Implementation would iterate through all indexes in CDX\n    # and add entries for the new record\n    Xbase.CdxParser.add_record_to_all_indexes(cdx, record_data, record_index)\n  end\nend\n```\n\nThis comprehensive guide covers all aspects of working with CDX indexes in Xbase, from basic operations to advanced optimization strategies.","ref":"indexes.html#coordinated-file-operations"},{"type":"extras","title":"Streaming Large Files","doc":"# Streaming Large Files\n\nXbase provides powerful streaming capabilities for processing large DBF files without loading everything into memory. This guide covers memory-efficient techniques for working with large datasets.","ref":"streaming.html"},{"type":"extras","title":"Understanding Streaming - Streaming Large Files","doc":"","ref":"streaming.html#understanding-streaming"},{"type":"extras","title":"Why Stream? - Streaming Large Files","doc":"When working with large DBF files, loading all records into memory can cause:\n- **Memory exhaustion** on systems with limited RAM\n- **Poor performance** due to excessive memory allocation\n- **Application crashes** when files exceed available memory\n- **Slow startup times** for large datasets","ref":"streaming.html#why-stream"},{"type":"extras","title":"Benefits of Streaming - Streaming Large Files","doc":"- **Constant Memory Usage**: Memory usage remains constant regardless of file size\n- **Lazy Evaluation**: Records are processed only when needed\n- **Early Termination**: Stop processing when conditions are met\n- **Composable**: Chain multiple stream operations together","ref":"streaming.html#benefits-of-streaming"},{"type":"extras","title":"Basic Streaming Operations - Streaming Large Files","doc":"","ref":"streaming.html#basic-streaming-operations"},{"type":"extras","title":"Reading Records as a Stream - Streaming Large Files","doc":"```elixir\n# Open file and create stream\n{:ok, dbf} = Xbase.Parser.open_dbf(\"large_dataset.dbf\")\n\n# Stream all records\nrecord_stream = Xbase.Parser.stream_records(dbf)\n\n# Process records one at a time\nresults = \n  record_stream\n  |> Stream.reject(fn record -> record.deleted end)\n  |> Stream.map(fn record -> process_record(record.data) end)\n  |> Enum.to_list()\n\nXbase.Parser.close_dbf(dbf)\n```","ref":"streaming.html#reading-records-as-a-stream"},{"type":"extras","title":"Filtering Large Datasets - Streaming Large Files","doc":"```elixir\n{:ok, dbf} = Xbase.Parser.open_dbf(\"customers.dbf\")\n\n# Find active customers in specific states\nactive_customers = \n  dbf\n  |> Xbase.Parser.stream_records()\n  |> Stream.reject(fn record -> record.deleted end)\n  |> Stream.filter(fn record -> \n    record.data[\"ACTIVE\"] == true and\n    record.data[\"STATE\"] in [\"CA\", \"NY\", \"TX\"]\n  end)\n  |> Stream.map(fn record -> \n    %{\n      name: record.data[\"NAME\"],\n      email: record.data[\"EMAIL\"],\n      state: record.data[\"STATE\"]\n    }\n  end)\n  |> Enum.to_list()\n\nIO.puts(\"Found #{length(active_customers)} active customers\")\nXbase.Parser.close_dbf(dbf)\n```","ref":"streaming.html#filtering-large-datasets"},{"type":"extras","title":"Counting and Aggregation - Streaming Large Files","doc":"```elixir\n{:ok, dbf} = Xbase.Parser.open_dbf(\"sales.dbf\")\n\n# Count records by category without loading all into memory\ncategory_counts = \n  dbf\n  |> Xbase.Parser.stream_records()\n  |> Stream.reject(fn record -> record.deleted end)\n  |> Stream.map(fn record -> record.data[\"CATEGORY\"] end)\n  |> Enum.frequencies()\n\nIO.inspect(category_counts)\nXbase.Parser.close_dbf(dbf)\n```","ref":"streaming.html#counting-and-aggregation"},{"type":"extras","title":"Advanced Streaming Patterns - Streaming Large Files","doc":"","ref":"streaming.html#advanced-streaming-patterns"},{"type":"extras","title":"Chunked Processing - Streaming Large Files","doc":"```elixir\ndefmodule ChunkedProcessor do\n  def process_in_chunks(dbf, chunk_size \\\\ 1000) do\n    dbf\n    |> Xbase.Parser.stream_records()\n    |> Stream.reject(fn record -> record.deleted end)\n    |> Stream.chunk_every(chunk_size)\n    |> Stream.map(&process_chunk/1)\n    |> Enum.to_list()\n  end\n  \n  defp process_chunk(records) do\n    # Process a chunk of records together\n    # This is useful for batch operations or database inserts\n    results = Enum.map(records, &transform_record/1)\n    \n    # Could insert batch into database here\n    # MyRepo.insert_all(Customer, results)\n    \n    length(results)\n  end\n  \n  defp transform_record(record) do\n    %{\n      name: String.upcase(record.data[\"NAME\"]),\n      email: String.downcase(record.data[\"EMAIL\"]),\n      processed_at: DateTime.utc_now()\n    }\n  end\nend\n```","ref":"streaming.html#chunked-processing"},{"type":"extras","title":"Streaming with Early Termination - Streaming Large Files","doc":"```elixir\ndefmodule EarlyTermination do\n  def find_first_match(dbf, condition_fn) do\n    dbf\n    |> Xbase.Parser.stream_records()\n    |> Stream.reject(fn record -> record.deleted end)\n    |> Enum.find(condition_fn)\n  end\n  \n  def take_sample(dbf, sample_size) do\n    dbf\n    |> Xbase.Parser.stream_records()\n    |> Stream.reject(fn record -> record.deleted end)\n    |> Stream.take(sample_size)\n    |> Enum.to_list()\n  end\n  \n  def process_until_condition(dbf, stop_condition) do\n    dbf\n    |> Xbase.Parser.stream_records()\n    |> Stream.reject(fn record -> record.deleted end)\n    |> Stream.take_while(fn record -> not stop_condition.(record) end)\n    |> Stream.map(&process_record/1)\n    |> Enum.to_list()\n  end\n  \n  defp process_record(record) do\n    # Your processing logic here\n    record.data\n  end\nend\n```","ref":"streaming.html#streaming-with-early-termination"},{"type":"extras","title":"Parallel Streaming - Streaming Large Files","doc":"```elixir\ndefmodule ParallelStreaming do\n  def parallel_process(dbf, concurrency \\\\ System.schedulers_online()) do\n    dbf\n    |> Xbase.Parser.stream_records()\n    |> Stream.reject(fn record -> record.deleted end)\n    |> Stream.chunk_every(100)  # Process in batches\n    |> Task.async_stream(\n      &process_batch/1,\n      max_concurrency: concurrency,\n      timeout: :infinity\n    )\n    |> Stream.map(fn {:ok, result} -> result end)\n    |> Enum.to_list()\n  end\n  \n  defp process_batch(records) do\n    # CPU-intensive processing on a batch of records\n    Enum.map(records, fn record ->\n      # Simulate complex processing\n      :timer.sleep(10)\n      transform_record(record)\n    end)\n  end\n  \n  defp transform_record(record) do\n    # Your transformation logic\n    %{\n      id: record.data[\"ID\"],\n      processed_data: process_field(record.data[\"DATA\"])\n    }\n  end\n  \n  defp process_field(data) do\n    # Simulate processing\n    String.upcase(data || \"\")\n  end\nend\n```","ref":"streaming.html#parallel-streaming"},{"type":"extras","title":"Memory-Efficient File Processing - Streaming Large Files","doc":"","ref":"streaming.html#memory-efficient-file-processing"},{"type":"extras","title":"Large File Analytics - Streaming Large Files","doc":"```elixir\ndefmodule LargeFileAnalytics do\n  def analyze_sales_data(file_path) do\n    {:ok, dbf} = Xbase.Parser.open_dbf(file_path)\n    \n    analytics = \n      dbf\n      |> Xbase.Parser.stream_records()\n      |> Stream.reject(fn record -> record.deleted end)\n      |> Stream.map(&extract_sales_data/1)\n      |> Enum.reduce(initial_analytics(), &update_analytics/2)\n    \n    Xbase.Parser.close_dbf(dbf)\n    finalize_analytics(analytics)\n  end\n  \n  defp extract_sales_data(record) do\n    %{\n      amount: record.data[\"AMOUNT\"] || 0,\n      date: record.data[\"SALE_DATE\"],\n      region: record.data[\"REGION\"],\n      product: record.data[\"PRODUCT\"]\n    }\n  end\n  \n  defp initial_analytics do\n    %{\n      total_sales: 0,\n      total_amount: 0.0,\n      region_totals: %{},\n      product_counts: %{},\n      monthly_sales: %{},\n      min_amount: :infinity,\n      max_amount: 0\n    }\n  end\n  \n  defp update_analytics(sale, analytics) do\n    month_key = format_month(sale.date)\n    \n    %{\n      analytics |\n      total_sales: analytics.total_sales + 1,\n      total_amount: analytics.total_amount + sale.amount,\n      region_totals: update_region_total(analytics.region_totals, sale.region, sale.amount),\n      product_counts: Map.update(analytics.product_counts, sale.product, 1, &(&1 + 1)),\n      monthly_sales: Map.update(analytics.monthly_sales, month_key, sale.amount, &(&1 + sale.amount)),\n      min_amount: min(analytics.min_amount, sale.amount),\n      max_amount: max(analytics.max_amount, sale.amount)\n    }\n  end\n  \n  defp update_region_total(region_totals, region, amount) do\n    Map.update(region_totals, region, amount, &(&1 + amount))\n  end\n  \n  defp format_month(date) when is_nil(date), do: \"unknown\"\n  defp format_month(%Date{} = date), do: \"#{date.year}-#{String.pad_leading(\"#{date.month}\", 2, \"0\")}\"\n  defp format_month(_), do: \"invalid\"\n  \n  defp finalize_analytics(analytics) do\n    %{\n      analytics |\n      average_amount: analytics.total_amount / max(analytics.total_sales, 1),\n      min_amount: if(analytics.min_amount == :infinity, do: 0, else: analytics.min_amount)\n    }\n  end\nend\n```","ref":"streaming.html#large-file-analytics"},{"type":"extras","title":"Data Migration Streaming - Streaming Large Files","doc":"```elixir\ndefmodule DataMigration do\n  def migrate_to_database(source_path, destination_repo) do\n    {:ok, dbf} = Xbase.Parser.open_dbf(source_path)\n    \n    migration_stats = \n      dbf\n      |> Xbase.Parser.stream_records()\n      |> Stream.reject(fn record -> record.deleted end)\n      |> Stream.map(&transform_for_database/1)\n      |> Stream.chunk_every(500)  # Insert in batches\n      |> Stream.with_index()\n      |> Enum.reduce(%{processed: 0, errors: 0}, fn {batch, index}, stats ->\n        case insert_batch(destination_repo, batch) do\n          {:ok, count} ->\n            IO.puts(\"Processed batch #{index + 1}: #{count} records\")\n            %{stats | processed: stats.processed + count}\n            \n          {:error, reason} ->\n            IO.puts(\"Error in batch #{index + 1}: #{inspect(reason)}\")\n            %{stats | errors: stats.errors + 1}\n        end\n      end)\n    \n    Xbase.Parser.close_dbf(dbf)\n    migration_stats\n  end\n  \n  defp transform_for_database(record) do\n    %{\n      external_id: record.data[\"ID\"],\n      name: record.data[\"NAME\"],\n      email: record.data[\"EMAIL\"],\n      phone: record.data[\"PHONE\"],\n      address: record.data[\"ADDRESS\"],\n      city: record.data[\"CITY\"],\n      state: record.data[\"STATE\"],\n      zip: record.data[\"ZIP\"],\n      created_at: DateTime.utc_now(),\n      updated_at: DateTime.utc_now()\n    }\n  end\n  \n  defp insert_batch(repo, batch) do\n    try do\n      {count, _} = repo.insert_all(\"customers\", batch)\n      {:ok, count}\n    rescue\n      error ->\n        {:error, error}\n    end\n  end\nend\n```","ref":"streaming.html#data-migration-streaming"},{"type":"extras","title":"Streaming with Memo Fields - Streaming Large Files","doc":"","ref":"streaming.html#streaming-with-memo-fields"},{"type":"extras","title":"Memory-Efficient Memo Processing - Streaming Large Files","doc":"```elixir\ndefmodule MemoStreaming do\n  def stream_with_selective_memo_loading(file_path) do\n    {:ok, handler} = Xbase.MemoHandler.open_dbf_with_memo(file_path)\n    \n    results = \n      handler.dbf\n      |> Xbase.Parser.stream_records()\n      |> Stream.reject(fn record -> record.deleted end)\n      |> Stream.map(fn record ->\n        # Only load memo content when certain conditions are met\n        if needs_memo_content?(record) do\n          # Load full record with memo content\n          {:ok, full_record} = Xbase.MemoHandler.read_record_with_memo(\n            handler, \n            record.data[\"_record_index\"] || 0\n          )\n          process_with_memo(full_record)\n        else\n          # Process without loading memo content\n          process_without_memo(record.data)\n        end\n      end)\n      |> Enum.to_list()\n    \n    Xbase.MemoHandler.close_memo_files(handler)\n    results\n  end\n  \n  defp needs_memo_content?(record) do\n    # Only load memo content for high-priority records\n    record.data[\"PRIORITY\"] == \"HIGH\" or\n    record.data[\"STATUS\"] == \"REVIEW_REQUIRED\"\n  end\n  \n  defp process_with_memo(record_data) do\n    %{\n      id: record_data[\"ID\"],\n      title: record_data[\"TITLE\"],\n      content_length: String.length(record_data[\"CONTENT\"] || \"\"),\n      has_memo: true\n    }\n  end\n  \n  defp process_without_memo(record_data) do\n    %{\n      id: record_data[\"ID\"],\n      title: record_data[\"TITLE\"],\n      has_memo: match?({:memo_ref, n} when n > 0, record_data[\"CONTENT\"])\n    }\n  end\nend\n```","ref":"streaming.html#memory-efficient-memo-processing"},{"type":"extras","title":"Performance Optimization - Streaming Large Files","doc":"","ref":"streaming.html#performance-optimization"},{"type":"extras","title":"Stream Optimization Strategies - Streaming Large Files","doc":"```elixir\ndefmodule StreamOptimization do\n  def optimized_processing(file_path, options \\\\ []) do\n    buffer_size = Keyword.get(options, :buffer_size, 8192)\n    chunk_size = Keyword.get(options, :chunk_size, 1000)\n    \n    {:ok, dbf} = Xbase.Parser.open_dbf(file_path, buffer_size: buffer_size)\n    \n    result = \n      dbf\n      |> Xbase.Parser.stream_records()\n      |> Stream.reject(fn record -> record.deleted end)\n      |> Stream.chunk_every(chunk_size)\n      |> Stream.map(&process_chunk_optimized/1)\n      |> Enum.reduce([], &combine_results/2)\n    \n    Xbase.Parser.close_dbf(dbf)\n    result\n  end\n  \n  defp process_chunk_optimized(records) do\n    # Use more efficient data structures for processing\n    records\n    |> Enum.map(&extract_key_data/1)\n    |> Enum.group_by(& &1.category)\n  end\n  \n  defp extract_key_data(record) do\n    %{\n      id: record.data[\"ID\"],\n      category: record.data[\"CATEGORY\"],\n      amount: record.data[\"AMOUNT\"] || 0\n    }\n  end\n  \n  defp combine_results(chunk_result, accumulator) do\n    Map.merge(accumulator, chunk_result, fn _key, acc_list, chunk_list ->\n      acc_list ++ chunk_list\n    end)\n  end\nend\n```","ref":"streaming.html#stream-optimization-strategies"},{"type":"extras","title":"Memory Monitoring - Streaming Large Files","doc":"```elixir\ndefmodule MemoryMonitor do\n  def process_with_monitoring(file_path) do\n    {:ok, dbf} = Xbase.Parser.open_dbf(file_path)\n    \n    initial_memory = get_memory_usage()\n    IO.puts(\"Starting memory usage: #{format_memory(initial_memory)}\")\n    \n    result = \n      dbf\n      |> Xbase.Parser.stream_records()\n      |> Stream.with_index()\n      |> Stream.map(fn {record, index} ->\n        if rem(index, 10000) == 0 do\n          current_memory = get_memory_usage()\n          IO.puts(\"Processed #{index} records, memory: #{format_memory(current_memory)}\")\n        end\n        \n        process_record(record)\n      end)\n      |> Enum.to_list()\n    \n    final_memory = get_memory_usage()\n    IO.puts(\"Final memory usage: #{format_memory(final_memory)}\")\n    IO.puts(\"Memory difference: #{format_memory(final_memory - initial_memory)}\")\n    \n    Xbase.Parser.close_dbf(dbf)\n    result\n  end\n  \n  defp get_memory_usage do\n    :erlang.memory(:total)\n  end\n  \n  defp format_memory(bytes) do\n    cond do\n      bytes >= 1_073_741_824 -> \"#{Float.round(bytes / 1_073_741_824, 2)} GB\"\n      bytes >= 1_048_576 -> \"#{Float.round(bytes / 1_048_576, 2)} MB\"\n      bytes >= 1024 -> \"#{Float.round(bytes / 1024, 2)} KB\"\n      true -> \"#{bytes} bytes\"\n    end\n  end\n  \n  defp process_record(record) do\n    # Your processing logic here\n    record.data[\"ID\"]\n  end\nend\n```","ref":"streaming.html#memory-monitoring"},{"type":"extras","title":"Error Handling in Streams - Streaming Large Files","doc":"","ref":"streaming.html#error-handling-in-streams"},{"type":"extras","title":"Resilient Stream Processing - Streaming Large Files","doc":"```elixir\ndefmodule ResilientStreaming do\n  def process_with_error_handling(file_path) do\n    {:ok, dbf} = Xbase.Parser.open_dbf(file_path)\n    \n    {successes, errors} = \n      dbf\n      |> Xbase.Parser.stream_records()\n      |> Stream.reject(fn record -> record.deleted end)\n      |> Stream.with_index()\n      |> Stream.map(&safe_process_record/1)\n      |> Enum.split_with(fn {status, _} -> status == :ok end)\n    \n    Xbase.Parser.close_dbf(dbf)\n    \n    success_count = length(successes)\n    error_count = length(errors)\n    \n    IO.puts(\"Successfully processed: #{success_count} records\")\n    IO.puts(\"Errors encountered: #{error_count} records\")\n    \n    if error_count > 0 do\n      IO.puts(\"First few errors:\")\n      errors\n      |> Enum.take(5)\n      |> Enum.each(fn {:error, {index, reason}} ->\n        IO.puts(\"  Record #{index}: #{inspect(reason)}\")\n      end)\n    end\n    \n    %{\n      successes: Enum.map(successes, fn {:ok, {_index, result}} -> result end),\n      errors: Enum.map(errors, fn {:error, {index, reason}} -> {index, reason} end)\n    }\n  end\n  \n  defp safe_process_record({record, index}) do\n    try do\n      result = process_record_with_validation(record)\n      {:ok, {index, result}}\n    rescue\n      error ->\n        {:error, {index, error}}\n    catch\n      :throw, reason ->\n        {:error, {index, reason}}\n    end\n  end\n  \n  defp process_record_with_validation(record) do\n    # Validate required fields\n    required_fields = [\"ID\", \"NAME\", \"EMAIL\"]\n    \n    missing_fields = \n      required_fields\n      |> Enum.filter(fn field -> is_nil(record.data[field]) or record.data[field] == \"\" end)\n    \n    if length(missing_fields) > 0 do\n      throw(\"Missing required fields: #{Enum.join(missing_fields, \", \")}\")\n    end\n    \n    # Validate email format\n    if not valid_email?(record.data[\"EMAIL\"]) do\n      throw(\"Invalid email format: #{record.data[\"EMAIL\"]}\")\n    end\n    \n    # Process the record\n    %{\n      id: record.data[\"ID\"],\n      name: String.trim(record.data[\"NAME\"]),\n      email: String.downcase(record.data[\"EMAIL\"])\n    }\n  end\n  \n  defp valid_email?(email) do\n    Regex.match?(~r/^[^\\s]+@[^\\s]+\\.[^\\s]+$/, email)\n  end\nend\n```","ref":"streaming.html#resilient-stream-processing"},{"type":"extras","title":"Best Practices - Streaming Large Files","doc":"","ref":"streaming.html#best-practices"},{"type":"extras","title":"1. Choose the Right Streaming Strategy - Streaming Large Files","doc":"```elixir\ndefmodule StreamingStrategy do\n  def choose_strategy(file_size, available_memory, processing_complexity) do\n    cond do\n      file_size  \n        :load_all  # Small file, load everything\n        \n      processing_complexity == :simple ->\n        :simple_stream  # Use basic streaming\n        \n      processing_complexity == :complex ->\n        :chunked_stream  # Process in chunks\n        \n      true ->\n        :parallel_stream  # Use parallel processing\n    end\n  end\nend\n```","ref":"streaming.html#1-choose-the-right-streaming-strategy"},{"type":"extras","title":"2. Monitor Resource Usage - Streaming Large Files","doc":"```elixir\ndefmodule ResourceMonitoring do\n  def monitor_stream_processing(stream_fn) do\n    start_time = System.monotonic_time(:millisecond)\n    start_memory = :erlang.memory(:total)\n    \n    result = stream_fn.()\n    \n    end_time = System.monotonic_time(:millisecond)\n    end_memory = :erlang.memory(:total)\n    \n    stats = %{\n      execution_time_ms: end_time - start_time,\n      memory_used: end_memory - start_memory,\n      peak_memory: :erlang.memory(:total)\n    }\n    \n    IO.puts(\"Stream processing completed:\")\n    IO.puts(\"  Time: #{stats.execution_time_ms}ms\")\n    IO.puts(\"  Memory used: #{format_bytes(stats.memory_used)}\")\n    \n    {result, stats}\n  end\n  \n  defp format_bytes(bytes) when bytes < 1024, do: \"#{bytes} B\"\n  defp format_bytes(bytes) when bytes < 1_048_576, do: \"#{Float.round(bytes / 1024, 1)} KB\"\n  defp format_bytes(bytes), do: \"#{Float.round(bytes / 1_048_576, 1)} MB\"\nend\n```","ref":"streaming.html#2-monitor-resource-usage"},{"type":"extras","title":"3. Handle Backpressure - Streaming Large Files","doc":"```elixir\ndefmodule BackpressureHandling do\n  def controlled_processing(file_path, max_concurrent_operations \\\\ 10) do\n    {:ok, dbf} = Xbase.Parser.open_dbf(file_path)\n    \n    dbf\n    |> Xbase.Parser.stream_records()\n    |> Stream.reject(fn record -> record.deleted end)\n    |> Stream.chunk_every(100)\n    |> Task.async_stream(\n      &process_batch/1,\n      max_concurrency: max_concurrent_operations,\n      timeout: 30_000,\n      on_timeout: :kill_task\n    )\n    |> Stream.map(fn \n      {:ok, result} -> result\n      {:exit, :timeout} -> {:error, :timeout}\n    end)\n    |> Enum.to_list()\n  end\n  \n  defp process_batch(records) do\n    # Simulate processing with potential delays\n    records\n    |> Enum.map(&process_single_record/1)\n    |> Enum.count()\n  end\n  \n  defp process_single_record(record) do\n    # Your processing logic here\n    :timer.sleep(:rand.uniform(10))  # Simulate variable processing time\n    record.data[\"ID\"]\n  end\nend\n```\n\nThis comprehensive guide provides the tools and patterns needed to efficiently process large DBF files using streaming techniques in Xbase.","ref":"streaming.html#3-handle-backpressure"},{"type":"extras","title":"Performance Optimization","doc":"# Performance Optimization\n\nThis guide covers advanced techniques for optimizing Xbase performance across different use cases, from small files to enterprise-scale datasets.","ref":"performance.html"},{"type":"extras","title":"Performance Fundamentals - Performance Optimization","doc":"","ref":"performance.html#performance-fundamentals"},{"type":"extras","title":"Understanding DBF Performance Characteristics - Performance Optimization","doc":"DBF file operations have different performance profiles:\n\n| Operation | Time Complexity | Memory Usage | Disk I/O |\n|-----------|----------------|--------------|----------|\n| Open file | O(1) | Constant | Single read |\n| Read record by index | O(1) | Constant | Single seek + read |\n| Stream records | O(n) | Constant | Sequential reads |\n| Search without index | O(n) | Constant | Full scan |\n| Search with index | O(log n) | Constant | B-tree traversal |\n| Append record | O(1) | Constant | Single write |\n| Update record | O(1) | Constant | Seek + write |\n| Pack file | O(n) | Variable | Full rewrite |","ref":"performance.html#understanding-dbf-performance-characteristics"},{"type":"extras","title":"Performance Bottlenecks - Performance Optimization","doc":"Common performance issues and their solutions:\n\n1. **Excessive Memory Usage**: Use streaming instead of loading all records\n2. **Slow Searches**: Implement indexes for frequently searched fields\n3. **I/O Bottlenecks**: Use batch operations and optimize file access patterns\n4. **CPU Intensive Processing**: Leverage parallel processing\n5. **Memo File Fragmentation**: Regular compaction and maintenance","ref":"performance.html#performance-bottlenecks"},{"type":"extras","title":"File Access Optimization - Performance Optimization","doc":"","ref":"performance.html#file-access-optimization"},{"type":"extras","title":"Efficient File Opening - Performance Optimization","doc":"```elixir\ndefmodule FileOptimization do\n  def optimized_file_access(file_path, options \\\\ []) do\n    # Configure optimal buffer sizes\n    buffer_size = Keyword.get(options, :buffer_size, 64 * 1024)  # 64KB\n    read_ahead = Keyword.get(options, :read_ahead, true)\n    \n    file_options = [\n      :binary,\n      :read,\n      {:read_ahead, if(read_ahead, do: buffer_size, else: false)},\n      {:buffer, buffer_size}\n    ]\n    \n    case Xbase.Parser.open_dbf(file_path, file_options) do\n      {:ok, dbf} ->\n        # Prefetch header and field information\n        {:ok, optimized_dbf} = prefetch_metadata(dbf)\n        {:ok, optimized_dbf}\n        \n      error ->\n        error\n    end\n  end\n  \n  defp prefetch_metadata(dbf) do\n    # Pre-load frequently accessed metadata\n    field_names = Enum.map(dbf.fields, & &1.name)\n    record_size = dbf.header.record_length\n    \n    optimized_dbf = %{\n      dbf |\n      cached_field_names: field_names,\n      cached_record_size: record_size,\n      performance_hints: %{\n        small_file: dbf.header.record_count < 10_000,\n        has_memo_fields: Enum.any?(dbf.fields, &(&1.type == \"M\"))\n      }\n    }\n    \n    {:ok, optimized_dbf}\n  end\nend\n```","ref":"performance.html#efficient-file-opening"},{"type":"extras","title":"Batch File Operations - Performance Optimization","doc":"```elixir\ndefmodule BatchOperations do\n  def batch_read_records(dbf, record_indices) when length(record_indices) > 100 do\n    # For large batches, group by proximity to minimize seeks\n    sorted_indices = Enum.sort(record_indices)\n    \n    sorted_indices\n    |> group_consecutive_ranges()\n    |> Enum.flat_map(&read_range/2, dbf)\n  end\n  \n  def batch_read_records(dbf, record_indices) do\n    # For small batches, read individually\n    Enum.map(record_indices, &Xbase.Parser.read_record(dbf, &1))\n  end\n  \n  defp group_consecutive_ranges(indices) do\n    indices\n    |> Enum.chunk_while(\n      [],\n      fn index, acc ->\n        case acc do\n          [] -> {:cont, [index]}\n          [last | _] when index == last + 1 -> {:cont, [index | acc]}\n          _ -> {:emit, Enum.reverse(acc), [index]}\n        end\n      end,\n      fn acc -> {:emit, Enum.reverse(acc), []} end\n    )\n  end\n  \n  defp read_range(dbf, range) when length(range) > 10 do\n    # Read contiguous ranges efficiently\n    start_index = List.first(range)\n    count = length(range)\n    Xbase.Parser.read_record_range(dbf, start_index, count)\n  end\n  \n  defp read_range(dbf, indices) do\n    Enum.map(indices, &Xbase.Parser.read_record(dbf, &1))\n  end\nend\n```","ref":"performance.html#batch-file-operations"},{"type":"extras","title":"Memory Management - Performance Optimization","doc":"","ref":"performance.html#memory-management"},{"type":"extras","title":"Stream-Based Processing - Performance Optimization","doc":"```elixir\ndefmodule MemoryEfficientProcessing do\n  def process_large_file(file_path, processor_fn) do\n    {:ok, dbf} = Xbase.Parser.open_dbf(file_path)\n    \n    # Use lazy streams to maintain constant memory usage\n    result = \n      dbf\n      |> Xbase.Parser.stream_records()\n      |> Stream.reject(fn record -> record.deleted end)\n      |> Stream.map(processor_fn)\n      |> Stream.chunk_every(1000)  # Process in chunks\n      |> Stream.map(&consolidate_chunk/1)\n      |> Enum.reduce(%{}, &merge_results/2)\n    \n    Xbase.Parser.close_dbf(dbf)\n    result\n  end\n  \n  defp consolidate_chunk(records) do\n    # Consolidate a chunk of processed records\n    records\n    |> Enum.group_by(& &1.category)\n    |> Map.new(fn {category, items} ->\n      {category, %{\n        count: length(items),\n        total_value: Enum.sum(Enum.map(items, & &1.value))\n      }}\n    end)\n  end\n  \n  defp merge_results(chunk_result, accumulator) do\n    Map.merge(accumulator, chunk_result, fn _key, acc_stats, chunk_stats ->\n      %{\n        count: acc_stats.count + chunk_stats.count,\n        total_value: acc_stats.total_value + chunk_stats.total_value\n      }\n    end)\n  end\nend\n```","ref":"performance.html#stream-based-processing"},{"type":"extras","title":"Memory Pool Management - Performance Optimization","doc":"```elixir\ndefmodule MemoryPool do\n  use GenServer\n  \n  def start_link(opts \\\\ []) do\n    GenServer.start_link(__MODULE__, opts, name: __MODULE__)\n  end\n  \n  def get_buffer(size) do\n    GenServer.call(__MODULE__, {:get_buffer, size})\n  end\n  \n  def return_buffer(buffer) do\n    GenServer.cast(__MODULE__, {:return_buffer, buffer})\n  end\n  \n  def init(opts) do\n    max_pool_size = Keyword.get(opts, :max_pool_size, 100)\n    default_buffer_size = Keyword.get(opts, :default_buffer_size, 8192)\n    \n    state = %{\n      pools: %{},\n      max_pool_size: max_pool_size,\n      default_buffer_size: default_buffer_size\n    }\n    \n    {:ok, state}\n  end\n  \n  def handle_call({:get_buffer, size}, _from, state) do\n    case Map.get(state.pools, size, []) do\n      [buffer | rest] ->\n        new_pools = Map.put(state.pools, size, rest)\n        {:reply, buffer, %{state | pools: new_pools}}\n        \n      [] ->\n        buffer = :binary.copy(<<0>>, size)\n        {:reply, buffer, state}\n    end\n  end\n  \n  def handle_cast({:return_buffer, buffer}, state) do\n    size = byte_size(buffer)\n    current_pool = Map.get(state.pools, size, [])\n    \n    new_pool = \n      if length(current_pool) < state.max_pool_size do\n        [buffer | current_pool]\n      else\n        current_pool  # Pool is full, discard buffer\n      end\n    \n    new_pools = Map.put(state.pools, size, new_pool)\n    {:noreply, %{state | pools: new_pools}}\n  end\nend\n```","ref":"performance.html#memory-pool-management"},{"type":"extras","title":"Indexing for Performance - Performance Optimization","doc":"","ref":"performance.html#indexing-for-performance"},{"type":"extras","title":"Strategic Index Creation - Performance Optimization","doc":"```elixir\ndefmodule IndexStrategy do\n  def analyze_query_patterns(dbf, query_log) do\n    field_access_frequency = \n      query_log\n      |> Enum.flat_map(& &1.accessed_fields)\n      |> Enum.frequencies()\n    \n    # Identify high-value index candidates\n    index_candidates = \n      field_access_frequency\n      |> Enum.filter(fn {_field, frequency} -> frequency > 100 end)\n      |> Enum.sort_by(fn {_field, frequency} -> frequency end, :desc)\n      |> Enum.take(5)  # Top 5 most accessed fields\n    \n    # Create indexes for high-traffic fields\n    Enum.each(index_candidates, fn {field_name, _frequency} ->\n      create_field_index(dbf, field_name)\n    end)\n    \n    index_candidates\n  end\n  \n  defp create_field_index(dbf, field_name) do\n    field = Enum.find(dbf.fields, &(&1.name == field_name))\n    cdx_path = String.replace(dbf.file_path, \".dbf\", \".cdx\")\n    \n    index_spec = %{\n      key_expression: field_name,\n      key_length: field.length,\n      index_name: \"IDX_#{field_name}\"\n    }\n    \n    case Xbase.CdxParser.add_index(cdx_path, index_spec) do\n      {:ok, _cdx} ->\n        IO.puts(\"Created index for #{field_name}\")\n      {:error, reason} ->\n        IO.puts(\"Failed to create index for #{field_name}: #{inspect(reason)}\")\n    end\n  end\nend\n```","ref":"performance.html#strategic-index-creation"},{"type":"extras","title":"Index-Optimized Queries - Performance Optimization","doc":"```elixir\ndefmodule OptimizedQueries do\n  def smart_search(dbf, cdx, search_criteria) do\n    case determine_best_index(cdx, search_criteria) do\n      {:ok, best_index} ->\n        index_based_search(best_index, search_criteria)\n        \n      :no_suitable_index ->\n        fallback_to_scan(dbf, search_criteria)\n    end\n  end\n  \n  defp determine_best_index(cdx, search_criteria) do\n    available_indexes = Xbase.CdxParser.list_indexes(cdx)\n    \n    # Score indexes based on search criteria\n    scored_indexes = \n      available_indexes\n      |> Enum.map(&score_index_for_criteria(&1, search_criteria))\n      |> Enum.filter(fn {_index, score} -> score > 0 end)\n      |> Enum.sort_by(fn {_index, score} -> score end, :desc)\n    \n    case scored_indexes do\n      [{best_index, _score} | _] -> {:ok, best_index}\n      [] -> :no_suitable_index\n    end\n  end\n  \n  defp score_index_for_criteria(index, criteria) do\n    score = \n      case criteria do\n        %{exact_match: field} when index.key_expression == field ->\n          100  # Perfect match for exact search\n          \n        %{range_query: field} when index.key_expression == field ->\n          90   # Excellent for range queries\n          \n        %{starts_with: field} when String.starts_with?(index.key_expression, field) ->\n          70   # Good for prefix searches\n          \n        _ ->\n          0    # Not suitable\n      end\n    \n    {index, score}\n  end\n  \n  defp index_based_search(index, criteria) do\n    case criteria do\n      %{exact_match: field, value: value} ->\n        Xbase.CdxParser.search_key(index, value)\n        \n      %{range_query: field, min_value: min_val, max_value: max_val} ->\n        Xbase.CdxParser.search_range(index, min_val, max_val)\n        \n      %{starts_with: field, prefix: prefix} ->\n        Xbase.CdxParser.search_partial(index, prefix)\n    end\n  end\n  \n  defp fallback_to_scan(dbf, criteria) do\n    IO.puts(\"Warning: No suitable index found, falling back to full table scan\")\n    \n    dbf\n    |> Xbase.Parser.stream_records()\n    |> Stream.filter(&matches_criteria?(&1, criteria))\n    |> Enum.to_list()\n  end\n  \n  defp matches_criteria?(record, criteria) do\n    case criteria do\n      %{exact_match: field, value: value} ->\n        record.data[field] == value\n        \n      %{range_query: field, min_value: min_val, max_value: max_val} ->\n        field_value = record.data[field]\n        field_value >= min_val and field_value <= max_val\n        \n      %{starts_with: field, prefix: prefix} ->\n        field_value = record.data[field] || \"\"\n        String.starts_with?(field_value, prefix)\n    end\n  end\nend\n```","ref":"performance.html#index-optimized-queries"},{"type":"extras","title":"Parallel Processing - Performance Optimization","doc":"","ref":"performance.html#parallel-processing"},{"type":"extras","title":"Concurrent Record Processing - Performance Optimization","doc":"```elixir\ndefmodule ParallelProcessing do\n  def parallel_transform(dbf, transform_fn, opts \\\\ []) do\n    concurrency = Keyword.get(opts, :concurrency, System.schedulers_online())\n    chunk_size = Keyword.get(opts, :chunk_size, 1000)\n    \n    dbf\n    |> Xbase.Parser.stream_records()\n    |> Stream.reject(fn record -> record.deleted end)\n    |> Stream.chunk_every(chunk_size)\n    |> Task.async_stream(\n      fn chunk -> parallel_process_chunk(chunk, transform_fn) end,\n      max_concurrency: concurrency,\n      timeout: :infinity,\n      ordered: false  # Allow out-of-order completion for better performance\n    )\n    |> Stream.map(fn {:ok, result} -> result end)\n    |> Enum.to_list()\n    |> List.flatten()\n  end\n  \n  defp parallel_process_chunk(chunk, transform_fn) do\n    chunk\n    |> Enum.map(transform_fn)\n  end\n  \n  def parallel_aggregation(dbf, aggregation_fns, opts \\\\ []) do\n    concurrency = Keyword.get(opts, :concurrency, System.schedulers_online())\n    \n    # Split work across multiple processes\n    task_results = \n      1..concurrency\n      |> Enum.map(fn worker_id ->\n        Task.async(fn ->\n          process_partition(dbf, worker_id, concurrency, aggregation_fns)\n        end)\n      end)\n      |> Task.await_many(:infinity)\n    \n    # Combine results from all workers\n    Enum.reduce(task_results, &merge_aggregation_results/2)\n  end\n  \n  defp process_partition(dbf, worker_id, total_workers, aggregation_fns) do\n    record_count = dbf.header.record_count\n    partition_size = div(record_count, total_workers)\n    start_index = (worker_id - 1) * partition_size\n    \n    end_index = \n      if worker_id == total_workers do\n        record_count - 1  # Last worker takes remaining records\n      else\n        start_index + partition_size - 1\n      end\n    \n    # Process assigned partition\n    start_index..end_index\n    |> Enum.reduce(initialize_aggregation(), fn index, acc ->\n      case Xbase.Parser.read_record(dbf, index) do\n        {:ok, record} when not record.deleted ->\n          apply_aggregation_fns(acc, record, aggregation_fns)\n        _ ->\n          acc\n      end\n    end)\n  end\n  \n  defp initialize_aggregation do\n    %{count: 0, sum: 0, min: :infinity, max: :neg_infinity}\n  end\n  \n  defp apply_aggregation_fns(acc, record, aggregation_fns) do\n    Enum.reduce(aggregation_fns, acc, fn {field, agg_type}, acc ->\n      value = record.data[field] || 0\n      apply_aggregation(acc, agg_type, value)\n    end)\n  end\n  \n  defp apply_aggregation(acc, :count, _value) do\n    %{acc | count: acc.count + 1}\n  end\n  \n  defp apply_aggregation(acc, :sum, value) when is_number(value) do\n    %{acc | sum: acc.sum + value}\n  end\n  \n  defp apply_aggregation(acc, :min, value) when is_number(value) do\n    %{acc | min: min(acc.min, value)}\n  end\n  \n  defp apply_aggregation(acc, :max, value) when is_number(value) do\n    %{acc | max: max(acc.max, value)}\n  end\n  \n  defp apply_aggregation(acc, _type, _value), do: acc\n  \n  defp merge_aggregation_results(result1, result2) do\n    %{\n      count: result1.count + result2.count,\n      sum: result1.sum + result2.sum,\n      min: min(result1.min, result2.min),\n      max: max(result1.max, result2.max)\n    }\n  end\nend\n```","ref":"performance.html#concurrent-record-processing"},{"type":"extras","title":"Load Balancing - Performance Optimization","doc":"```elixir\ndefmodule LoadBalancer do\n  use GenServer\n  \n  def start_link(worker_count \\\\ System.schedulers_online()) do\n    GenServer.start_link(__MODULE__, worker_count, name: __MODULE__)\n  end\n  \n  def submit_work(work_item) do\n    GenServer.call(__MODULE__, {:submit_work, work_item})\n  end\n  \n  def init(worker_count) do\n    workers = \n      1..worker_count\n      |> Enum.map(fn id ->\n        {:ok, pid} = Worker.start_link(id)\n        %{id: id, pid: pid, current_load: 0}\n      end)\n    \n    {:ok, %{workers: workers, work_queue: :queue.new()}}\n  end\n  \n  def handle_call({:submit_work, work_item}, _from, state) do\n    case find_least_loaded_worker(state.workers) do\n      {:ok, worker} ->\n        Worker.assign_work(worker.pid, work_item)\n        updated_workers = update_worker_load(state.workers, worker.id, +1)\n        {:reply, {:ok, worker.id}, %{state | workers: updated_workers}}\n        \n      :all_busy ->\n        updated_queue = :queue.in(work_item, state.work_queue)\n        {:reply, {:queued, :queue.len(updated_queue)}, %{state | work_queue: updated_queue}}\n    end\n  end\n  \n  def handle_info({:work_completed, worker_id}, state) do\n    updated_workers = update_worker_load(state.workers, worker_id, -1)\n    \n    # Try to assign queued work to newly available worker\n    case :queue.out(state.work_queue) do\n      {{:value, work_item}, updated_queue} ->\n        worker = Enum.find(updated_workers, &(&1.id == worker_id))\n        Worker.assign_work(worker.pid, work_item)\n        final_workers = update_worker_load(updated_workers, worker_id, +1)\n        {:noreply, %{state | workers: final_workers, work_queue: updated_queue}}\n        \n      {:empty, _queue} ->\n        {:noreply, %{state | workers: updated_workers}}\n    end\n  end\n  \n  defp find_least_loaded_worker(workers) do\n    case Enum.min_by(workers, & &1.current_load) do\n      %{current_load: load} = worker when load < 5 -> {:ok, worker}\n      _ -> :all_busy\n    end\n  end\n  \n  defp update_worker_load(workers, worker_id, load_delta) do\n    Enum.map(workers, fn worker ->\n      if worker.id == worker_id do\n        %{worker | current_load: worker.current_load + load_delta}\n      else\n        worker\n      end\n    end)\n  end\nend\n```","ref":"performance.html#load-balancing"},{"type":"extras","title":"Memo Field Optimization - Performance Optimization","doc":"","ref":"performance.html#memo-field-optimization"},{"type":"extras","title":"Efficient Memo Caching - Performance Optimization","doc":"```elixir\ndefmodule MemoCache do\n  use GenServer\n  \n  @cache_size 1000  # Maximum number of cached memo blocks\n  @ttl_ms 300_000   # 5 minutes TTL\n  \n  def start_link(_opts) do\n    GenServer.start_link(__MODULE__, %{}, name: __MODULE__)\n  end\n  \n  def get_memo(dbt_file, block_number) do\n    case GenServer.call(__MODULE__, {:get_memo, dbt_file.file_path, block_number}) do\n      {:hit, content} ->\n        {:ok, content}\n      :miss ->\n        case Xbase.DbtParser.read_memo(dbt_file, block_number) do\n          {:ok, content} ->\n            GenServer.cast(__MODULE__, {:cache_memo, dbt_file.file_path, block_number, content})\n            {:ok, content}\n          error ->\n            error\n        end\n    end\n  end\n  \n  def init(_) do\n    # Start cleanup timer\n    :timer.send_interval(60_000, self(), :cleanup)  # Cleanup every minute\n    \n    state = %{\n      cache: %{},\n      access_times: %{},\n      size: 0\n    }\n    \n    {:ok, state}\n  end\n  \n  def handle_call({:get_memo, file_path, block_number}, _from, state) do\n    key = {file_path, block_number}\n    \n    case Map.get(state.cache, key) do\n      nil ->\n        {:reply, :miss, state}\n      content ->\n        # Update access time\n        updated_access_times = Map.put(state.access_times, key, System.monotonic_time(:millisecond))\n        {:reply, {:hit, content}, %{state | access_times: updated_access_times}}\n    end\n  end\n  \n  def handle_cast({:cache_memo, file_path, block_number, content}, state) do\n    key = {file_path, block_number}\n    now = System.monotonic_time(:millisecond)\n    \n    # Evict if cache is full\n    state = \n      if state.size >= @cache_size do\n        evict_lru_item(state)\n      else\n        state\n      end\n    \n    # Add new item\n    updated_cache = Map.put(state.cache, key, content)\n    updated_access_times = Map.put(state.access_times, key, now)\n    \n    new_state = %{\n      state |\n      cache: updated_cache,\n      access_times: updated_access_times,\n      size: state.size + 1\n    }\n    \n    {:noreply, new_state}\n  end\n  \n  def handle_info(:cleanup, state) do\n    now = System.monotonic_time(:millisecond)\n    cutoff = now - @ttl_ms\n    \n    # Remove expired entries\n    expired_keys = \n      state.access_times\n      |> Enum.filter(fn {_key, access_time} -> access_time   Enum.map(fn {key, _time} -> key end)\n    \n    updated_cache = Map.drop(state.cache, expired_keys)\n    updated_access_times = Map.drop(state.access_times, expired_keys)\n    \n    new_state = %{\n      state |\n      cache: updated_cache,\n      access_times: updated_access_times,\n      size: state.size - length(expired_keys)\n    }\n    \n    {:noreply, new_state}\n  end\n  \n  defp evict_lru_item(state) do\n    # Find least recently used item\n    {lru_key, _time} = Enum.min_by(state.access_times, fn {_key, time} -> time end)\n    \n    %{\n      state |\n      cache: Map.delete(state.cache, lru_key),\n      access_times: Map.delete(state.access_times, lru_key),\n      size: state.size - 1\n    }\n  end\nend\n```","ref":"performance.html#efficient-memo-caching"},{"type":"extras","title":"Memo Prefetching - Performance Optimization","doc":"```elixir\ndefmodule MemoPrefetcher do\n  def prefetch_memo_blocks(dbt_file, record_stream) do\n    # Analyze upcoming memo references\n    memo_refs = \n      record_stream\n      |> Stream.take(100)  # Look ahead 100 records\n      |> Stream.flat_map(&extract_memo_refs/1)\n      |> Stream.uniq()\n      |> Enum.to_list()\n    \n    # Prefetch memo blocks in background\n    Task.start(fn -> \n      batch_read_memo_blocks(dbt_file, memo_refs)\n    end)\n    \n    record_stream\n  end\n  \n  defp extract_memo_refs(record) do\n    record.data\n    |> Enum.filter(fn {_field, value} -> match?({:memo_ref, _}, value) end)\n    |> Enum.map(fn {_field, {:memo_ref, block_num}} -> block_num end)\n    |> Enum.filter(&(&1 > 0))\n  end\n  \n  defp batch_read_memo_blocks(dbt_file, block_numbers) do\n    # Group consecutive blocks for efficient reading\n    block_numbers\n    |> Enum.sort()\n    |> group_consecutive_blocks()\n    |> Enum.each(&read_block_range(dbt_file, &1))\n  end\n  \n  defp group_consecutive_blocks(blocks) do\n    blocks\n    |> Enum.chunk_while(\n      [],\n      fn block, acc ->\n        case acc do\n          [] -> {:cont, [block]}\n          [last | _] when block == last + 1 -> {:cont, [block | acc]}\n          _ -> {:emit, Enum.reverse(acc), [block]}\n        end\n      end,\n      fn acc -> {:emit, Enum.reverse(acc), []} end\n    )\n  end\n  \n  defp read_block_range(dbt_file, block_range) when length(block_range) > 1 do\n    # Read multiple consecutive blocks in one operation\n    first_block = List.first(block_range)\n    block_count = length(block_range)\n    \n    case Xbase.DbtParser.read_memo_range(dbt_file, first_block, block_count) do\n      {:ok, memo_contents} ->\n        # Cache the prefetched content\n        block_range\n        |> Enum.zip(memo_contents)\n        |> Enum.each(fn {block_num, content} ->\n          MemoCache.cache_memo(dbt_file.file_path, block_num, content)\n        end)\n        \n      {:error, reason} ->\n        IO.puts(\"Prefetch failed: #{inspect(reason)}\")\n    end\n  end\n  \n  defp read_block_range(dbt_file, [block_num]) do\n    # Single block read\n    case Xbase.DbtParser.read_memo(dbt_file, block_num) do\n      {:ok, content} ->\n        MemoCache.cache_memo(dbt_file.file_path, block_num, content)\n      {:error, _reason} ->\n        :ok  # Ignore prefetch failures\n    end\n  end\nend\n```","ref":"performance.html#memo-prefetching"},{"type":"extras","title":"Benchmarking and Profiling - Performance Optimization","doc":"","ref":"performance.html#benchmarking-and-profiling"},{"type":"extras","title":"Performance Measurement - Performance Optimization","doc":"```elixir\ndefmodule PerformanceBenchmark do\n  def benchmark_operations(file_path, operations \\\\ [:read, :search, :update]) do\n    {:ok, dbf} = Xbase.Parser.open_dbf(file_path)\n    \n    results = \n      operations\n      |> Enum.map(&benchmark_operation(dbf, &1))\n      |> Map.new()\n    \n    Xbase.Parser.close_dbf(dbf)\n    results\n  end\n  \n  defp benchmark_operation(dbf, :read) do\n    record_count = min(1000, dbf.header.record_count)\n    indices = Enum.take_random(0..(dbf.header.record_count - 1), record_count)\n    \n    {time_micro, _results} = :timer.tc(fn ->\n      Enum.map(indices, &Xbase.Parser.read_record(dbf, &1))\n    end)\n    \n    {:read_performance, %{\n      records_read: record_count,\n      total_time_ms: time_micro / 1000,\n      avg_time_per_record_ms: time_micro / 1000 / record_count,\n      records_per_second: record_count * 1_000_000 / time_micro\n    }}\n  end\n  \n  defp benchmark_operation(dbf, :search) do\n    # Benchmark linear search\n    search_fn = fn record -> \n      record.data[\"ID\"] != nil and not record.deleted\n    end\n    \n    {time_micro, results} = :timer.tc(fn ->\n      dbf\n      |> Xbase.Parser.stream_records()\n      |> Stream.filter(search_fn)\n      |> Enum.count()\n    end)\n    \n    {:search_performance, %{\n      records_scanned: dbf.header.record_count,\n      matches_found: results,\n      total_time_ms: time_micro / 1000,\n      records_per_second: dbf.header.record_count * 1_000_000 / time_micro\n    }}\n  end\n  \n  defp benchmark_operation(dbf, :update) do\n    # Benchmark record updates\n    update_count = min(100, dbf.header.record_count)\n    indices = Enum.take_random(0..(dbf.header.record_count - 1), update_count)\n    \n    {time_micro, _results} = :timer.tc(fn ->\n      Enum.map(indices, fn index ->\n        Xbase.Parser.update_record(dbf, index, %{\"UPDATED\" => true})\n      end)\n    end)\n    \n    {:update_performance, %{\n      records_updated: update_count,\n      total_time_ms: time_micro / 1000,\n      avg_time_per_update_ms: time_micro / 1000 / update_count,\n      updates_per_second: update_count * 1_000_000 / time_micro\n    }}\n  end\nend\n```","ref":"performance.html#performance-measurement"},{"type":"extras","title":"Profiling Tools - Performance Optimization","doc":"```elixir\ndefmodule ProfilerTools do\n  def profile_memory_usage(operation_fn) do\n    # Force garbage collection before measurement\n    :erlang.garbage_collect()\n    \n    initial_memory = :erlang.memory()\n    initial_processes = length(:erlang.processes())\n    \n    {time_micro, result} = :timer.tc(operation_fn)\n    \n    final_memory = :erlang.memory()\n    final_processes = length(:erlang.processes())\n    \n    memory_diff = calculate_memory_difference(initial_memory, final_memory)\n    \n    profile = %{\n      execution_time_ms: time_micro / 1000,\n      memory_usage: memory_diff,\n      process_count_change: final_processes - initial_processes,\n      result: result\n    }\n    \n    print_profile_report(profile)\n    {result, profile}\n  end\n  \n  defp calculate_memory_difference(initial, final) do\n    %{\n      total_change: final[:total] - initial[:total],\n      processes_change: final[:processes] - initial[:processes],\n      system_change: final[:system] - initial[:system],\n      atom_change: final[:atom] - initial[:atom],\n      binary_change: final[:binary] - initial[:binary],\n      ets_change: final[:ets] - initial[:ets]\n    }\n  end\n  \n  defp print_profile_report(profile) do\n    IO.puts(\"\\n=== Performance Profile ===\")\n    IO.puts(\"Execution Time: #{Float.round(profile.execution_time_ms, 2)}ms\")\n    IO.puts(\"Total Memory Change: #{format_bytes(profile.memory_usage.total_change)}\")\n    IO.puts(\"Process Memory Change: #{format_bytes(profile.memory_usage.processes_change)}\")\n    IO.puts(\"System Memory Change: #{format_bytes(profile.memory_usage.system_change)}\")\n    IO.puts(\"Process Count Change: #{profile.process_count_change}\")\n    IO.puts(\"===========================\\n\")\n  end\n  \n  defp format_bytes(bytes) when bytes < 1024, do: \"#{bytes} B\"\n  defp format_bytes(bytes) when bytes < 1_048_576, do: \"#{Float.round(bytes / 1024, 1)} KB\"\n  defp format_bytes(bytes) when bytes < 1_073_741_824, do: \"#{Float.round(bytes / 1_048_576, 1)} MB\"\n  defp format_bytes(bytes), do: \"#{Float.round(bytes / 1_073_741_824, 1)} GB\"\n  \n  def cpu_profile(operation_fn, duration_seconds \\\\ 10) do\n    # Start CPU profiling\n    :eprof.start()\n    :eprof.start_profiling([self()])\n    \n    # Run the operation\n    result = operation_fn.()\n    \n    # Stop profiling and analyze\n    :eprof.stop_profiling()\n    :eprof.analyze(:total)\n    :eprof.stop()\n    \n    result\n  end\nend\n```","ref":"performance.html#profiling-tools"},{"type":"extras","title":"Production Optimization - Performance Optimization","doc":"","ref":"performance.html#production-optimization"},{"type":"extras","title":"Configuration Tuning - Performance Optimization","doc":"```elixir\ndefmodule ProductionConfig do\n  def optimize_for_environment(environment) do\n    case environment do\n      :development ->\n        %{\n          buffer_size: 8_192,          # 8KB - Small for quick testing\n          cache_size: 100,             # Small cache\n          parallel_workers: 2,         # Minimal parallelism\n          prefetch_enabled: false      # Disable prefetching\n        }\n        \n      :staging ->\n        %{\n          buffer_size: 32_768,         # 32KB\n          cache_size: 500,             # Medium cache\n          parallel_workers: 4,         # Moderate parallelism\n          prefetch_enabled: true       # Enable prefetching\n        }\n        \n      :production ->\n        %{\n          buffer_size: 65_536,         # 64KB - Optimal for most systems\n          cache_size: 2000,            # Large cache\n          parallel_workers: System.schedulers_online(),\n          prefetch_enabled: true,\n          compression_enabled: true,    # Enable compression for large files\n          index_auto_creation: true     # Auto-create indexes for frequent queries\n        }\n    end\n  end\n  \n  def apply_configuration(config) do\n    # Configure application environment\n    Application.put_env(:xbase, :buffer_size, config.buffer_size)\n    Application.put_env(:xbase, :cache_size, config.cache_size)\n    Application.put_env(:xbase, :parallel_workers, config.parallel_workers)\n    Application.put_env(:xbase, :prefetch_enabled, config.prefetch_enabled)\n    \n    # Start performance-critical services\n    {:ok, _} = MemoCache.start_link(cache_size: config.cache_size)\n    {:ok, _} = LoadBalancer.start_link(config.parallel_workers)\n    \n    :ok\n  end\nend\n```","ref":"performance.html#configuration-tuning"},{"type":"extras","title":"Monitoring and Alerting - Performance Optimization","doc":"```elixir\ndefmodule PerformanceMonitor do\n  use GenServer\n  \n  def start_link(_opts) do\n    GenServer.start_link(__MODULE__, %{}, name: __MODULE__)\n  end\n  \n  def record_operation(operation_type, duration_ms, metadata \\\\ %{}) do\n    GenServer.cast(__MODULE__, {:record_operation, operation_type, duration_ms, metadata})\n  end\n  \n  def get_performance_stats do\n    GenServer.call(__MODULE__, :get_stats)\n  end\n  \n  def init(_) do\n    # Start metrics collection timer\n    :timer.send_interval(60_000, self(), :collect_metrics)  # Every minute\n    \n    state = %{\n      operations: %{},\n      alerts: [],\n      start_time: System.monotonic_time(:millisecond)\n    }\n    \n    {:ok, state}\n  end\n  \n  def handle_cast({:record_operation, operation_type, duration_ms, metadata}, state) do\n    operations = Map.update(state.operations, operation_type, [], fn existing ->\n      # Keep only last 1000 operations per type\n      [%{duration: duration_ms, metadata: metadata, timestamp: System.monotonic_time(:millisecond)} | existing]\n      |> Enum.take(1000)\n    end)\n    \n    # Check for performance alerts\n    alerts = check_performance_alerts(operation_type, duration_ms, state.alerts)\n    \n    {:noreply, %{state | operations: operations, alerts: alerts}}\n  end\n  \n  def handle_call(:get_stats, _from, state) do\n    stats = calculate_performance_stats(state.operations)\n    {:reply, stats, state}\n  end\n  \n  def handle_info(:collect_metrics, state) do\n    # Collect system metrics\n    memory_usage = :erlang.memory(:total)\n    process_count = length(:erlang.processes())\n    \n    # Log performance metrics\n    IO.puts(\"System Metrics - Memory: #{format_bytes(memory_usage)}, Processes: #{process_count}\")\n    \n    {:noreply, state}\n  end\n  \n  defp check_performance_alerts(operation_type, duration_ms, existing_alerts) do\n    alert_thresholds = %{\n      read_record: 100,      # Alert if read takes > 100ms\n      search_records: 5000,  # Alert if search takes > 5s\n      update_record: 200,    # Alert if update takes > 200ms\n      append_record: 150     # Alert if append takes > 150ms\n    }\n    \n    threshold = Map.get(alert_thresholds, operation_type, 1000)\n    \n    if duration_ms > threshold do\n      alert = %{\n        type: :performance_degradation,\n        operation: operation_type,\n        duration: duration_ms,\n        threshold: threshold,\n        timestamp: System.monotonic_time(:millisecond)\n      }\n      \n      # Keep only recent alerts (last hour)\n      cutoff = System.monotonic_time(:millisecond) - 3_600_000\n      recent_alerts = Enum.filter(existing_alerts, fn alert -> alert.timestamp > cutoff end)\n      \n      [alert | recent_alerts]\n    else\n      existing_alerts\n    end\n  end\n  \n  defp calculate_performance_stats(operations) do\n    operations\n    |> Enum.map(fn {operation_type, operation_list} ->\n      durations = Enum.map(operation_list, & &1.duration)\n      \n      stats = %{\n        count: length(durations),\n        avg_duration: average(durations),\n        min_duration: Enum.min(durations, fn -> 0 end),\n        max_duration: Enum.max(durations, fn -> 0 end),\n        p95_duration: percentile(durations, 95),\n        p99_duration: percentile(durations, 99)\n      }\n      \n      {operation_type, stats}\n    end)\n    |> Map.new()\n  end\n  \n  defp average([]), do: 0\n  defp average(list), do: Enum.sum(list) / length(list)\n  \n  defp percentile([], _), do: 0\n  defp percentile(list, percentile) do\n    sorted = Enum.sort(list)\n    index = trunc(length(sorted) * percentile / 100)\n    Enum.at(sorted, index, 0)\n  end\n  \n  defp format_bytes(bytes) when bytes < 1024, do: \"#{bytes} B\"\n  defp format_bytes(bytes) when bytes < 1_048_576, do: \"#{Float.round(bytes / 1024, 1)} KB\"\n  defp format_bytes(bytes), do: \"#{Float.round(bytes / 1_048_576, 1)} MB\"\nend\n```\n\nThis comprehensive performance guide provides the tools and techniques needed to optimize Xbase applications for any scale, from development environments to high-performance production systems.","ref":"performance.html#monitoring-and-alerting"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}